open Parser

module Default = struct
  let value (type a) : a MenhirInterpreter.symbol -> a = function
    | MenhirInterpreter.T MenhirInterpreter.T_error -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_WITH -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_WHILE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_WHEN -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_VIRTUAL -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_VAL -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_UNDERSCORE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_UIDENT -> "<invalid-uident>"
    | MenhirInterpreter.T MenhirInterpreter.T_TYPE_DISAMBIGUATOR -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_TYPE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_TRY -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_TRUE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_TO -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_TILDE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_THEN -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_STRUCT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_STRING -> ("<invalid-string>", Location.none, Some "<invalid-string>")
    | MenhirInterpreter.T MenhirInterpreter.T_STAR -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_SLASH -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_SIG -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_SEMISEMI -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_SEMI -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_RPAREN -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_REC -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_RBRACKET -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_RBRACE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_QUOTED_STRING_ITEM -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_QUOTED_STRING_EXPR -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_QUOTE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_QUESTION -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_PRIVATE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_PREFIXOP -> "<invalid-prefixop>"
    | MenhirInterpreter.T MenhirInterpreter.T_PLUSEQ -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_PLUSDOT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_PLUS -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_PERCENT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_OR -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_OPTLABEL -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_OPEN -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_OF -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_OBJECT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_NONREC -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_NEW -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_MUTABLE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_MODULE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_MINUSGREATER -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_MINUSDOT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_MINUS -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_METHOD -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_MATCH -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LPAREN -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LIDENT -> "<invalid-lident>"
    | MenhirInterpreter.T MenhirInterpreter.T_LETOP -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_LET -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LESSMINUS -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LESS -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACKETPERCENTPERCENT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACKETPERCENT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACKETLESS -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACKETGREATER -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACKETBAR -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACKETATATAT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACKETATAT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACKETAT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACKET -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACELESS -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LBRACE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LAZY -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_LABEL -> "<invalid-label>"
    | MenhirInterpreter.T MenhirInterpreter.T_INT -> ("<invalid-int>", None)
    | MenhirInterpreter.T MenhirInterpreter.T_INITIALIZER -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_INHERIT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_INFIXOP4 -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_INFIXOP3 -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_INFIXOP2 -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_INFIXOP1 -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_INFIXOP0 -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_INCLUDE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_IN -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_IF -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_HASHOP -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_HASH -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_GREATERRBRACKET -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_GREATERRBRACE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_GREATER -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_FUNCTOR -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_FUNCTION -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_FUN -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_FOR -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_FLOAT -> ("<invalid-float>", None)
    | MenhirInterpreter.T MenhirInterpreter.T_FALSE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_EXTERNAL -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_EXCEPTION -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_EQUAL -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_EOL -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_EOF -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_END -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_ELSE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_DOWNTO -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_DOTOP -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_DOTDOT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_DOT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_DONE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_DOCSTRING -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_DO -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_CONSTRAINT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_COMMENT -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_COMMA -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_COLONGREATER -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_COLONEQUAL -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_COLONCOLON -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_COLON -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_CLASS -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_CHAR -> '?'
    | MenhirInterpreter.T MenhirInterpreter.T_BEGIN -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_BARRBRACKET -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_BARBAR -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_BAR -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_BANG -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_BACKQUOTE -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_ASSERT -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_AS -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_ANDOP -> raise Not_found
    | MenhirInterpreter.T MenhirInterpreter.T_AND -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_AMPERSAND -> ()
    | MenhirInterpreter.T MenhirInterpreter.T_AMPERAMPER -> ()
    | MenhirInterpreter.N MenhirInterpreter.N_with_type_binder -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_with_constraint -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_virtual_with_private_flag -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_virtual_with_mutable_flag -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_virtual_flag -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_value_description -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_value -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_val_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_val_ident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_val_extra_ident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_use_file -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_type_variance -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_type_variable -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_type_parameters -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_type_parameter -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_type_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_type_kind -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_type_constraint -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_tuple_type -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_toplevel_phrase -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_toplevel_directive -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_tag_field -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_subtractive -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_structure_item -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_structure -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_strict_binding -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_str_exception_declaration -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_single_attr_id -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_simple_pattern_not_ident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_simple_pattern -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_simple_expr -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_simple_delimited_pattern -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_signed_constant -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_signature_item -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_signature -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_sig_exception_declaration -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_seq_expr -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_separated_or_terminated_nonempty_list_SEMI_record_expr_field_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_separated_or_terminated_nonempty_list_SEMI_pattern_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_separated_or_terminated_nonempty_list_SEMI_object_expr_field_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_separated_or_terminated_nonempty_list_SEMI_expr_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_row_field -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_separated_nontrivial_llist_STAR_atomic_type_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_separated_nontrivial_llist_COMMA_expr_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_separated_nontrivial_llist_COMMA_core_type_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_separated_nonempty_llist_STAR_atomic_type_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_separated_nonempty_llist_COMMA_type_parameter_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_separated_nonempty_llist_COMMA_core_type_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_separated_nonempty_llist_BAR_row_field_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_separated_nonempty_llist_AND_with_constraint_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_separated_nonempty_llist_AMPERSAND_core_type_no_attr_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_preceded_or_separated_nonempty_llist_BAR_match_case_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_nonempty_llist_typevar_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_nonempty_llist_name_tag_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_nonempty_llist_labeled_simple_expr_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_nonempty_llist_functor_arg_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_llist_preceded_CONSTRAINT_constrain__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_bar_llist_extension_constructor_declaration_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_bar_llist_extension_constructor_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_reversed_bar_llist_constructor_declaration_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_record_expr_content -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_rec_flag -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_private_virtual_flags -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_private_flag -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_primitive_declaration -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_post_item_attribute -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_possibly_poly_core_type_no_attr_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_possibly_poly_core_type_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_payload -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_pattern_var -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_pattern_no_exn -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_pattern_gen -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_pattern_comma_list_pattern_no_exn_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_pattern_comma_list_pattern_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_pattern -> Annot.Pat.mk ()
    | MenhirInterpreter.N MenhirInterpreter.N_parse_val_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_pattern -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_mty_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_module_type -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_module_expr -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_mod_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_mod_ext_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_expression -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_core_type -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_constr_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_parse_any_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_paren_module_expr -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_optlabel -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_option_type_constraint_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_option_preceded_EQUAL_seq_expr__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_option_preceded_EQUAL_pattern__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_option_preceded_EQUAL_module_type__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_option_preceded_EQUAL_expr__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_option_preceded_COLON_core_type__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_option_preceded_AS_mkrhs_LIDENT___ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_option_SEMI_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_option_BAR_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_opt_ampersand -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_operator -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_open_description -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_open_declaration -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_nonempty_type_kind -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_nonempty_list_mkrhs_raw_string__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_nonempty_list_mkrhs_LIDENT__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_name_tag -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mutable_virtual_flags -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mutable_flag -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mty_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_module_type_subst -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_module_type_declaration -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_module_type -> Annot.Mty.mk ()
    | MenhirInterpreter.N MenhirInterpreter.N_module_subst -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_module_name -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_module_expr -> Annot.Mod.mk ()
    | MenhirInterpreter.N MenhirInterpreter.N_module_declaration_body -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_module_binding_body -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mod_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mod_ext_longident_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mod_ext_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mk_longident_mod_longident_val_ident_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mk_longident_mod_longident_UIDENT_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mk_longident_mod_longident_LIDENT_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mk_longident_mod_ext_longident_ident_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mk_longident_mod_ext_longident___anonymous_41_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_mk_longident_mod_ext_longident_LIDENT_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_method_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_meth_list -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_match_case -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_listx_SEMI_record_pat_field_UNDERSCORE_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_use_file_element_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_text_str_structure_item__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_text_cstr_class_field__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_text_csig_class_sig_field__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_structure_element_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_signature_element_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_post_item_attribute_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_generic_and_type_declaration_type_subst_kind__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_generic_and_type_declaration_type_kind__ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_attribute_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_and_module_declaration_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_and_module_binding_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_and_class_type_declaration_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_and_class_description_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_list_and_class_declaration_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_letop_bindings -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_letop_binding_body -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_let_pattern -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_let_bindings_no_ext_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_let_bindings_ext_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_let_binding_body_no_punning -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_let_binding_body -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_labeled_simple_pattern -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_labeled_simple_expr -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_label_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_label_let_pattern -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_label_declarations -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_label_declaration_semi -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_label_declaration -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_item_extension -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_interface -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_index_mod -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_implementation -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_ident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_generic_type_declaration_nonrec_flag_type_kind_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_generic_type_declaration_no_nonrec_flag_type_subst_kind_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_generic_constructor_declaration_epsilon_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_generic_constructor_declaration_BAR_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_generalized_constructor_arguments -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_functor_arg -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_function_type -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_fun_def -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_fun_binding -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_formal_class_parameters -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_floating_attribute -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_extension_constructor_rebind_epsilon_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_extension_constructor_rebind_BAR_ -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_extension -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_ext -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_expr -> Annot.Exp.mk ()
    | MenhirInterpreter.N MenhirInterpreter.N_direction_flag -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_core_type -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_constructor_declarations -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_constructor_arguments -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_constrain_field -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_constr_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_constr_ident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_constr_extra_nonprefix_ident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_constant -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_clty_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_type_declarations -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_type -> Annot.Cty.mk ()
    | MenhirInterpreter.N MenhirInterpreter.N_class_simple_expr -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_signature -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_sig_field -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_self_type -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_self_pattern -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_fun_def -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_fun_binding -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_field -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_class_expr -> Annot.Cl.mk ()
    | MenhirInterpreter.N MenhirInterpreter.N_attribute -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_attr_id -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_atomic_type -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_any_longident -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_and_let_binding -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_alias_type -> raise Not_found
    | MenhirInterpreter.N MenhirInterpreter.N_additive -> raise Not_found
end

let default_value = Default.value

open MenhirInterpreter

type action =
  | Abort
  | R of int
  | S : 'a symbol -> action
  | Sub of action list

type decision =
  | Nothing
  | One of action list
  | Select of (int -> action list)

let depth =
  [|0;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;2;3;2;2;1;2;1;2;3;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;1;2;1;2;3;4;5;2;3;4;5;2;3;4;5;1;1;1;1;1;1;2;3;1;4;5;1;1;2;3;1;1;1;1;2;1;2;3;1;1;1;2;2;3;4;1;1;2;1;2;3;1;2;4;1;2;1;1;2;2;1;1;1;2;2;1;2;3;2;3;5;6;1;1;1;1;1;2;1;2;3;2;1;1;1;2;1;2;1;1;1;2;3;4;5;6;7;1;2;1;2;3;1;1;1;2;3;1;1;1;2;2;1;2;2;1;1;2;3;4;1;1;5;6;6;1;2;3;4;1;1;2;1;1;1;1;1;2;3;4;1;2;3;1;2;3;1;1;2;3;3;1;1;4;1;2;1;1;1;2;3;1;1;1;1;2;1;1;1;2;1;1;2;3;1;1;1;1;2;1;2;2;1;1;1;1;1;2;3;4;2;3;2;3;1;2;2;1;2;1;1;2;1;2;1;1;3;2;3;2;1;2;3;4;1;2;3;3;1;1;3;4;2;3;1;2;1;3;4;2;1;3;2;3;4;5;1;2;1;2;1;2;3;2;3;4;5;3;4;3;4;4;5;6;2;1;2;2;1;1;2;3;1;1;2;1;1;1;1;1;1;4;1;1;2;3;1;1;1;2;3;4;1;2;3;1;1;1;2;3;2;3;2;1;2;1;1;2;3;1;2;4;5;6;1;1;1;2;3;2;3;2;3;3;4;5;2;3;2;3;2;4;4;5;4;5;3;4;2;3;1;2;3;3;2;3;4;5;1;6;5;2;2;3;1;1;2;1;2;3;3;4;2;1;2;3;1;1;2;3;4;5;1;2;1;2;2;3;1;1;2;3;4;1;5;2;1;2;3;1;2;4;5;4;5;6;2;3;4;5;1;1;2;3;4;5;2;1;2;3;3;1;1;1;4;5;2;3;2;3;4;2;3;4;1;3;2;3;2;1;2;3;4;5;3;4;1;5;2;3;2;3;3;4;5;2;2;1;1;6;7;1;1;1;1;1;1;1;2;3;1;2;3;1;1;1;2;1;1;2;3;4;1;1;4;5;6;7;8;9;10;1;1;1;1;2;3;4;1;2;3;1;2;3;1;1;2;1;2;3;1;1;2;1;2;3;3;4;5;1;2;4;5;6;7;1;1;2;3;4;5;1;2;3;4;2;3;2;3;1;1;1;2;3;1;2;1;2;3;4;4;5;2;1;2;1;2;2;3;2;3;4;5;1;2;1;2;1;1;1;1;1;2;3;1;2;3;2;3;2;1;2;1;2;2;3;2;3;4;5;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;2;3;1;2;1;1;2;3;4;1;2;1;2;1;2;3;1;1;1;2;5;2;3;4;5;6;7;8;3;2;3;4;5;6;7;2;3;4;2;1;2;3;4;5;1;2;3;2;3;2;3;2;3;2;3;2;1;1;2;3;1;3;1;2;4;2;3;3;4;5;3;4;5;3;4;5;6;7;1;2;3;5;6;7;5;6;7;3;1;2;2;3;4;5;6;7;3;4;5;6;7;3;4;5;6;7;2;3;4;5;6;7;3;4;5;6;7;3;4;5;6;7;3;4;5;6;7;8;9;5;6;7;8;9;5;6;7;8;9;3;4;5;1;2;2;1;2;4;5;3;4;5;3;4;5;6;1;1;7;8;9;10;11;2;1;2;3;4;1;2;3;4;1;2;5;8;4;5;3;4;5;2;3;3;2;4;2;3;1;4;5;6;7;8;5;1;2;3;2;3;4;2;3;1;1;4;5;3;4;4;5;3;4;4;5;3;4;5;3;1;2;3;1;1;2;3;4;5;1;4;5;1;2;3;3;4;4;4;5;2;3;2;2;3;4;2;2;3;2;3;8;3;4;5;6;7;2;3;4;5;1;2;1;2;3;4;6;7;8;1;2;2;3;4;1;1;2;3;1;5;1;1;1;1;2;3;1;2;3;4;5;6;7;1;2;3;1;2;1;1;2;3;2;1;1;2;3;4;5;6;4;2;3;4;2;6;7;8;9;1;2;3;1;4;5;6;2;4;5;2;2;3;2;2;3;2;2;3;4;5;6;6;7;8;2;3;3;4;4;5;6;4;5;5;6;7;5;6;7;7;8;9;5;6;2;3;4;5;1;2;3;4;5;1;2;6;7;2;3;4;5;6;7;1;2;3;4;5;6;8;4;5;6;1;2;1;2;3;4;1;2;1;2;3;4;5;1;2;3;4;5;1;2;3;6;7;1;2;8;9;1;1;2;3;4;5;1;1;2;3;6;7;8;5;6;7;1;1;1;2;3;4;5;6;2;3;4;5;1;2;3;4;5;6;7;8;2;3;4;5;6;7;4;5;6;7;8;1;2;3;4;5;6;7;9;4;5;6;7;1;2;5;6;1;2;1;2;3;4;5;1;2;3;4;1;2;3;4;1;5;1;2;3;6;7;8;1;2;1;2;3;3;1;2;1;2;1;2;3;4;5;6;7;1;2;1;2;1;2;3;4;5;6;7;1;2;1;2;3;4;5;6;1;2;3;4;2;3;1;1;1;7;2;3;4;5;6;3;4;1;2;1;2;3;3;4;4;5;1;2;1;1;2;9;10;1;2;3;4;5;6;7;8;9;11;2;3;4;5;6;7;1;2;3;4;1;1;1;2;1;2;3;1;1;4;1;3;5;8;9;1;2;3;4;5;6;7;8;9;10;1;1;1;1;1;1;1;1;2;1;2;1;1;2;3;4;5;6;7;8;2;1;1;2;3;4;5;1;1;2;3;1;1;2;3;4;1;1;2;6;7;8;9;1;1;1;2;3;4;5;6;4;4;1;2;3;3;4;5;3;3;1;2;1;1;2;2;1;2;1;2;3;4;5;6;1;1;2;3;1;1;2;3;4;5;6;5;6;7;2;3;1;1;2;1;2;2;3;4;5;2;3;4;5;4;5;6;1;1;2;1;3;4;5;6;7;8;9;10;11;6;7;8;5;2;3;1;1;2;1;2;2;3;4;5;2;3;4;5;6;7;8;9;10;5;6;7;4;1;2;3;4;1;2;3;1;1;2;3;4;5;6;1;2;3;4;1;2;1;2;1;2;1;1;2;1;3;2;2;3;2;3;7;3;4;5;6;2;3;4;5;2;3;3;4;5;4;1;2;5;6;2;3;4;5;1;2;3;4;4;5;1;2;1;1;2;2;1;2;3;4;1;2;7;8;1;2;3;4;5;6;7;8;9;1;1;1;1;1;1;1;1;2;1;1;2;1;2;1;1;1;1;2;3;3;4;1;1;3;4;2;3;4;2;3;4;5;7;8;2;3;3;4;5;4;5;6;4;5;6;3;4;8;5;6;7;1;2;3;4;5;8;9;2;2;1;1;1;1;1;2;3;4;3;4;3;4;5;6;1;7;1;2;3;2;2;3;3;4;5;2;3;4;5;4;2;3;2;3;2;3;2;3;4;2;2;2;2;7;8;9;4;5;6;7;8;9;5;6;7;8;9;2;1;1;3;4;5;6;6;7;3;4;3;4;5;6;7;1;2;1;0;1;2;1;0;1;2;3;1;1;1;2;3;4;5;3;3;1;1;1;1;2;0;1;1;2;0;1;1;2;0;1;2;1;0;1;1;2;0;1;1;2;0;1;1;2;0;1;1;2;0;1;1;2;0;1;2;1;0;1;2;1;1;2;0;1;2;3;3;3;3;3;3;1;1;1;2;1;2;1;2;3;1;2;0;1;1;1;2;2;2;3;4;2;1;1;2;3;4;1;2;|]

let can_pop (type a) : a terminal -> bool = function
  | T_WITH -> true
  | T_WHILE -> true
  | T_WHEN -> true
  | T_VIRTUAL -> true
  | T_VAL -> true
  | T_UNDERSCORE -> true
  | T_TYPE -> true
  | T_TRY -> true
  | T_TRUE -> true
  | T_TO -> true
  | T_TILDE -> true
  | T_THEN -> true
  | T_STRUCT -> true
  | T_STAR -> true
  | T_SLASH -> true
  | T_SIG -> true
  | T_SEMISEMI -> true
  | T_SEMI -> true
  | T_RPAREN -> true
  | T_REC -> true
  | T_RBRACKET -> true
  | T_RBRACE -> true
  | T_QUOTE -> true
  | T_QUESTION -> true
  | T_PRIVATE -> true
  | T_PLUSEQ -> true
  | T_PLUSDOT -> true
  | T_PLUS -> true
  | T_PERCENT -> true
  | T_OR -> true
  | T_OPEN -> true
  | T_OF -> true
  | T_OBJECT -> true
  | T_NONREC -> true
  | T_NEW -> true
  | T_MUTABLE -> true
  | T_MODULE -> true
  | T_MINUSGREATER -> true
  | T_MINUSDOT -> true
  | T_MINUS -> true
  | T_METHOD -> true
  | T_MATCH -> true
  | T_LPAREN -> true
  | T_LET -> true
  | T_LESSMINUS -> true
  | T_LESS -> true
  | T_LBRACKETPERCENTPERCENT -> true
  | T_LBRACKETPERCENT -> true
  | T_LBRACKETLESS -> true
  | T_LBRACKETGREATER -> true
  | T_LBRACKETBAR -> true
  | T_LBRACKETATATAT -> true
  | T_LBRACKETATAT -> true
  | T_LBRACKETAT -> true
  | T_LBRACKET -> true
  | T_LBRACELESS -> true
  | T_LBRACE -> true
  | T_LAZY -> true
  | T_INITIALIZER -> true
  | T_INHERIT -> true
  | T_INCLUDE -> true
  | T_IN -> true
  | T_IF -> true
  | T_HASH -> true
  | T_GREATERRBRACKET -> true
  | T_GREATERRBRACE -> true
  | T_GREATER -> true
  | T_FUNCTOR -> true
  | T_FUNCTION -> true
  | T_FUN -> true
  | T_FOR -> true
  | T_FALSE -> true
  | T_EXTERNAL -> true
  | T_EXCEPTION -> true
  | T_EQUAL -> true
  | T_EOL -> true
  | T_END -> true
  | T_ELSE -> true
  | T_DOWNTO -> true
  | T_DOTDOT -> true
  | T_DOT -> true
  | T_DONE -> true
  | T_DO -> true
  | T_CONSTRAINT -> true
  | T_COMMA -> true
  | T_COLONGREATER -> true
  | T_COLONEQUAL -> true
  | T_COLONCOLON -> true
  | T_COLON -> true
  | T_CLASS -> true
  | T_BEGIN -> true
  | T_BARRBRACKET -> true
  | T_BARBAR -> true
  | T_BAR -> true
  | T_BANG -> true
  | T_BACKQUOTE -> true
  | T_ASSERT -> true
  | T_AS -> true
  | T_AND -> true
  | T_AMPERSAND -> true
  | T_AMPERAMPER -> true
  | _ -> false

let recover =
  let r0 = Sub [S (N N_expr); R 572] in
  let r1 = Sub [S (T T_DONE); R 133] in
  let r2 = Sub [r0; r1] in
  let r3 = Sub [S (T T_DO); r2] in
  let r4 = Sub [r0; r3] in
  let r5 = Sub [R 270; r4] in
  let r6 = Sub [S (T T_WITH); R 716; R 42] in
  let r7 = Sub [S (N N_pattern); R 496] in
  let r8 = Sub [S (T T_QUESTION); r7] in
  let r9 = Sub [S (T T_RBRACKET); R 44] in
  let r10 = Sub [r8; r9] in
  let r11 = Sub [S (T T_LIDENT); R 780] in
  let r12 = Sub [S (T T_UNDERSCORE); R 25] in
  let r13 = Sub [r12; R 754] in
  let r14 = Sub [r13; R 194] in
  let r15 = Sub [r14; R 17] in
  let r16 = Sub [r15; R 117] in
  let r17 = Sub [r16; R 498] in
  let r18 = Sub [R 276; R 788] in
  let r19 = Sub [r17; r18] in
  let r20 = Sub [S (T T_COLON); r19] in
  let r21 = Sub [r11; r20] in
  let r22 = Sub [R 270; r21] in
  let r23 = Sub [S (T T_RPAREN); R 779] in
  let r24 = Sub [S (T T_COLONEQUAL); R 429; r23] in
  let r25 = Sub [S (T T_RPAREN); R 401] in
  let r26 = Sub [R 214; r25] in
  let r27 = Sub [S (T T_RBRACKET); R 403] in
  let r28 = Sub [S (T T_RBRACE); R 405] in
  let r29 = Sub [S (T T_COLON); R 451] in
  let r30 = Sub [S (T T_RPAREN); R 23] in
  let r31 = Sub [S (N N_module_type); r30] in
  let r32 = Sub [R 270; r31] in
  let r33 = Sub [R 179; r32] in
  let r34 = Sub [S (T T_LIDENT); R 212] in
  let r35 = Sub [r34; R 24] in
  let r36 = Sub [R 278; R 577] in
  let r37 = Sub [S (T T_END); R 356] in
  let r38 = Sub [r36; r37] in
  let r39 = Sub [R 276; R 210] in
  let r40 = Sub [R 527; r39] in
  let r41 = Sub [R 759; r40] in
  let r42 = Sub [S (T T_LIDENT); r41] in
  let r43 = Sub [S (T T_UNDERSCORE); R 768; R 763] in
  let r44 = Sub [R 769; r43] in
  let r45 = Sub [r44; R 548] in
  let r46 = Sub [S (T T_RPAREN); R 766] in
  let r47 = Sub [S (T T_DOTDOT); R 386] in
  let r48 = Sub [S (T T_RPAREN); R 105] in
  let r49 = Sub [S (T T_COLONCOLON); r48] in
  let r50 = Sub [r14; R 196] in
  let r51 = Sub [S (T T_MINUSGREATER); r50] in
  let r52 = Sub [r13; r51] in
  let r53 = Sub [r15; R 500] in
  let r54 = Sub [R 270; R 307] in
  let r55 = Sub [r53; r54] in
  let r56 = Sub [S (T T_RBRACKET); R 181] in
  let r57 = Sub [r8; r56] in
  let r58 = Sub [R 276; R 209] in
  let r59 = Sub [R 527; r58] in
  let r60 = Sub [S (T T_RBRACKET); R 502] in
  let r61 = Sub [r8; r60] in
  let r62 = Sub [S (T T_DOT); R 302] in
  let r63 = Sub [S (T T_MINUSGREATER); r62] in
  let r64 = Sub [S (N N_pattern); r63] in
  let r65 = Sub [r64; R 537] in
  let r66 = Sub [r65; R 130] in
  let r67 = Sub [S (T T_WITH); r66] in
  let r68 = Sub [r0; r67] in
  let r69 = Sub [R 270; r68] in
  let r70 = Sub [S (T T_UNDERSCORE); R 636] in
  let r71 = Sub [S (T T_END); R 621] in
  let r72 = Sub [R 287; r71] in
  let r73 = Sub [R 69; r72] in
  let r74 = Sub [R 270; r73] in
  let r75 = Sub [S (T T_RPAREN); R 67] in
  let r76 = Sub [S (T T_UNDERSCORE); R 354] in
  let r77 = Sub [S (T T_RPAREN); R 652] in
  let r78 = Sub [r76; r77] in
  let r79 = Sub [R 270; r78] in
  let r80 = Sub [S (T T_RPAREN); R 653] in
  let r81 = Sub [S (N N_module_expr); R 358] in
  let r82 = Sub [R 270; r81] in
  let r83 = Sub [S (T T_OF); r82] in
  let r84 = Sub [S (T T_END); R 344] in
  let r85 = Sub [R 281; R 722; r84] in
  let r86 = Sub [R 276; R 394] in
  let r87 = Sub [S (N N_module_expr); r86] in
  let r88 = Sub [R 270; r87] in
  let r89 = Sub [R 276; R 395] in
  let r90 = Sub [S (N N_module_expr); r89] in
  let r91 = Sub [R 270; r90] in
  let r92 = Sub [S (T T_RPAREN); R 453] in
  let r93 = Sub [S (T T_RPAREN); R 454] in
  let r94 = Sub [S (N N_expr); r93] in
  let r95 = Sub [S (T T_LIDENT); R 327] in
  let r96 = Sub [r95; R 66] in
  let r97 = Sub [r96; R 618] in
  let r98 = Sub [R 270; r97] in
  let r99 = Sub [S (T T_LIDENT); R 328] in
  let r100 = Sub [S (T T_DOT); r99] in
  let r101 = Sub [r65; R 129] in
  let r102 = Sub [S (T T_WITH); r101] in
  let r103 = Sub [r0; r102] in
  let r104 = Sub [R 270; r103] in
  let r105 = Sub [S (N N_expr); R 167] in
  let r106 = Sub [r11; R 255] in
  let r107 = Sub [r0; R 165] in
  let r108 = Sub [S (T T_IN); r107] in
  let r109 = Sub [r95; R 226] in
  let r110 = Sub [R 444; R 296] in
  let r111 = Sub [R 438; r110] in
  let r112 = Sub [S (T T_RBRACE); R 601] in
  let r113 = Sub [r16; R 559] in
  let r114 = Sub [r113; R 544] in
  let r115 = Sub [S (T T_RBRACKET); R 39] in
  let r116 = Sub [r114; r115] in
  let r117 = Sub [S (T T_RBRACKET); R 37] in
  let r118 = Sub [r34; R 375] in
  let r119 = Sub [S (T T_BACKQUOTE); r118] in
  let r120 = Sub [R 270; R 742] in
  let r121 = Sub [S (T T_RBRACKET); R 34] in
  let r122 = Sub [S (T T_LIDENT); R 317] in
  let r123 = Sub [r122; R 95] in
  let r124 = Sub [S (T T_UIDENT); R 335; R 333] in
  let r125 = Sub [S (T T_RPAREN); R 334] in
  let r126 = Sub [S (T T_UIDENT); R 337] in
  let r127 = Sub [S (T T_RBRACKET); R 35] in
  let r128 = Sub [r14; R 195] in
  let r129 = Sub [S (T T_MINUSGREATER); r128] in
  let r130 = Sub [R 270; R 741] in
  let r131 = Sub [r15; R 540; r130] in
  let r132 = Sub [r34; R 18] in
  let r133 = Sub [S (T T_RBRACKET); R 36] in
  let r134 = Sub [r114; r133] in
  let r135 = Sub [S (T T_RBRACKET); R 40] in
  let r136 = Sub [S (T T_UNDERSCORE); R 654; R 649] in
  let r137 = Sub [r136; R 484] in
  let r138 = Sub [R 270; r137] in
  let r139 = Sub [r122; R 761] in
  let r140 = Sub [S (N N_pattern); R 475] in
  let r141 = Sub [R 270; r140] in
  let r142 = Sub [S (T T_RPAREN); R 650] in
  let r143 = Sub [S (N N_pattern); r142] in
  let r144 = Sub [S (T T_LIDENT); R 376] in
  let r145 = Sub [r136; R 482] in
  let r146 = Sub [S (T T_RPAREN); r145] in
  let r147 = Sub [S (T T_RPAREN); R 109] in
  let r148 = Sub [S (T T_RPAREN); R 664] in
  let r149 = Sub [S (T T_RPAREN); R 108] in
  let r150 = Sub [S (T T_RBRACKET); R 661] in
  let r151 = Sub [S (T T_RBRACKET); R 602] in
  let r152 = Sub [S (T T_LIDENT); R 238] in
  let r153 = Sub [S (T T_LIDENT); R 224] in
  let r154 = Sub [S (T T_RPAREN); R 237] in
  let r155 = Sub [S (T T_RPAREN); R 233] in
  let r156 = Sub [R 446; r155] in
  let r157 = Sub [r0; R 124] in
  let r158 = Sub [S (T T_IN); r157] in
  let r159 = Sub [S (N N_module_expr); r158] in
  let r160 = Sub [R 270; r159] in
  let r161 = Sub [R 179; r160] in
  let r162 = Sub [r0; R 125] in
  let r163 = Sub [S (T T_IN); r162] in
  let r164 = Sub [S (N N_module_expr); r163] in
  let r165 = Sub [R 270; r164] in
  let r166 = Sub [S (T T_RPAREN); R 198] in
  let r167 = Sub [S (T T_LPAREN); r166; R 529] in
  let r168 = Sub [S (N N_module_expr); R 345] in
  let r169 = Sub [S (T T_MINUSGREATER); r168] in
  let r170 = Sub [r167; r169] in
  let r171 = Sub [S (T T_RPAREN); R 199] in
  let r172 = Sub [S (N N_module_type); r171] in
  let r173 = Sub [S (T T_RPAREN); R 359] in
  let r174 = Sub [S (N N_module_type); R 357] in
  let r175 = Sub [S (T T_MINUSGREATER); r174] in
  let r176 = Sub [r167; r175] in
  let r177 = Sub [r34; R 325; R 367] in
  let r178 = Sub [S (N N_module_type); R 802] in
  let r179 = Sub [S (T T_MODULE); S (T T_TYPE); r177; S (T T_COLONEQUAL); r178] in
  let r180 = Sub [r15; R 798] in
  let r181 = Sub [S (T T_COLONEQUAL); r180] in
  let r182 = Sub [r109; r181] in
  let r183 = Sub [R 527; R 797] in
  let r184 = Sub [r16; R 528] in
  let r185 = Sub [S (T T_EQUAL); r184] in
  let r186 = Sub [S (T T_UIDENT); R 329; R 338] in
  let r187 = Sub [r124; R 799] in
  let r188 = Sub [S (T T_EQUAL); r187] in
  let r189 = Sub [S (N N_module_type); R 801] in
  let r190 = Sub [S (T T_EQUAL); r189] in
  let r191 = Sub [S (T T_UIDENT); R 330] in
  let r192 = Sub [S (T T_RPAREN); R 452] in
  let r193 = Sub [R 440; R 563] in
  let r194 = Sub [R 440; R 569] in
  let r195 = Sub [R 448; r194] in
  let r196 = Sub [r109; r195] in
  let r197 = Sub [r196; R 513] in
  let r198 = Sub [S (T T_RBRACE); R 638] in
  let r199 = Sub [S (T T_END); R 617] in
  let r200 = Sub [R 270; r199] in
  let r201 = Sub [r70; R 136] in
  let r202 = Sub [R 270; r201] in
  let r203 = Sub [S (T T_RPAREN); R 637] in
  let r204 = Sub [S (T T_RPAREN); R 647] in
  let r205 = Sub [S (N N_module_type); r204] in
  let r206 = Sub [S (T T_COLON); r205] in
  let r207 = Sub [S (N N_module_expr); r206] in
  let r208 = Sub [R 270; r207] in
  let r209 = Sub [r0; R 256] in
  let r210 = Sub [S (T T_EQUAL); r209] in
  let r211 = Sub [S (N N_expr); R 132] in
  let r212 = Sub [S (T T_THEN); r211] in
  let r213 = Sub [r0; r212] in
  let r214 = Sub [R 270; r213] in
  let r215 = Sub [r65; R 126] in
  let r216 = Sub [R 270; r215] in
  let r217 = Sub [r0; R 301] in
  let r218 = Sub [S (T T_MINUSGREATER); r217] in
  let r219 = Sub [S (T T_TILDE); r152] in
  let r220 = Sub [r0; R 190] in
  let r221 = Sub [S (T T_MINUSGREATER); r220] in
  let r222 = Sub [r221; R 127] in
  let r223 = Sub [r219; r222] in
  let r224 = Sub [R 270; r223] in
  let r225 = Sub [S (T T_RPAREN); R 235] in
  let r226 = Sub [R 446; r225] in
  let r227 = Sub [r221; R 128] in
  let r228 = Sub [S (T T_RPAREN); r227] in
  let r229 = Sub [r144; r228] in
  let r230 = Sub [S (T T_DONE); R 134] in
  let r231 = Sub [r0; r230] in
  let r232 = Sub [S (T T_DO); r231] in
  let r233 = Sub [r0; r232] in
  let r234 = Sub [S (T T_DOWNTO); R 120; r233] in
  let r235 = Sub [r0; r234] in
  let r236 = Sub [S (T T_EQUAL); r235] in
  let r237 = Sub [S (N N_pattern); r236] in
  let r238 = Sub [R 270; r237] in
  let r239 = Sub [r70; R 135] in
  let r240 = Sub [R 270; r239] in
  let r241 = Sub [S (N N_expr); R 560] in
  let r242 = Sub [S (T T_RPAREN); R 610] in
  let r243 = Sub [r241; r242] in
  let r244 = Sub [S (T T_LPAREN); r243] in
  let r245 = Sub [r16; R 758] in
  let r246 = Sub [S (T T_RPAREN); R 230] in
  let r247 = Sub [S (T T_COLONGREATER); r245; r246] in
  let r248 = Sub [r16; R 756] in
  let r249 = Sub [r109; R 630] in
  let r250 = Sub [S (T T_RPAREN); R 607] in
  let r251 = Sub [r0; r250] in
  let r252 = Sub [r0; R 164] in
  let r253 = Sub [r0; R 575] in
  let r254 = Sub [r0; R 719] in
  let r255 = Sub [S (T T_EQUAL); r254] in
  let r256 = Sub [r255; R 242] in
  let r257 = Sub [r11; r256; R 241] in
  let r258 = Sub [R 276; R 19] in
  let r259 = Sub [r257; r258] in
  let r260 = Sub [r255; R 188] in
  let r261 = Sub [r260; R 721] in
  let r262 = Sub [S (T T_RPAREN); r261] in
  let r263 = Sub [r144; r262] in
  let r264 = Sub [r0; R 189] in
  let r265 = Sub [r0; R 245] in
  let r266 = Sub [S (T T_EQUAL); r265] in
  let r267 = Sub [r16; r266] in
  let r268 = Sub [S (T T_DOT); r267] in
  let r269 = Sub [r0; R 244] in
  let r270 = Sub [S (T T_EQUAL); r269] in
  let r271 = Sub [r16; r270] in
  let r272 = Sub [r0; R 243] in
  let r273 = Sub [r0; R 247] in
  let r274 = Sub [S (T T_EQUAL); r273] in
  let r275 = Sub [r0; R 246] in
  let r276 = Sub [S (T T_RBRACKET); R 609] in
  let r277 = Sub [r0; r276] in
  let r278 = Sub [S (T T_RBRACE); R 608] in
  let r279 = Sub [r0; r278] in
  let r280 = Sub [S (T T_RPAREN); R 611] in
  let r281 = Sub [r241; r280] in
  let r282 = Sub [S (T T_LPAREN); r281] in
  let r283 = Sub [S (T T_RBRACKET); R 615] in
  let r284 = Sub [r241; r283] in
  let r285 = Sub [S (T T_RBRACE); R 613] in
  let r286 = Sub [r241; r285] in
  let r287 = Sub [S (T T_RBRACKET); R 614] in
  let r288 = Sub [r241; r287] in
  let r289 = Sub [S (T T_RBRACE); R 612] in
  let r290 = Sub [r241; r289] in
  let r291 = Sub [r221; R 193] in
  let r292 = Sub [S (T T_RPAREN); r291] in
  let r293 = Sub [r144; r292] in
  let r294 = Sub [r0; R 191] in
  let r295 = Sub [S (T T_MINUSGREATER); r294] in
  let r296 = Sub [r0; R 257] in
  let r297 = Sub [S (T T_GREATERRBRACE); R 632] in
  let r298 = Sub [S (T T_RBRACE); R 639] in
  let r299 = Sub [r196; R 514] in
  let r300 = Sub [S (T T_LPAREN); r203] in
  let r301 = Sub [S (T T_DOT); r300] in
  let r302 = Sub [S (T T_RBRACKET); R 644] in
  let r303 = Sub [S (N N_module_expr); R 339] in
  let r304 = Sub [S (T T_EQUAL); r303] in
  let r305 = Sub [r0; R 122] in
  let r306 = Sub [S (T T_IN); r305] in
  let r307 = Sub [r304; r306] in
  let r308 = Sub [r76; r307] in
  let r309 = Sub [R 270; r308] in
  let r310 = Sub [S (N N_module_expr); R 340] in
  let r311 = Sub [S (T T_EQUAL); r310] in
  let r312 = Sub [S (T T_UIDENT); R 104] in
  let r313 = Sub [r0; R 123] in
  let r314 = Sub [S (T T_IN); r313] in
  let r315 = Sub [R 270; r314] in
  let r316 = Sub [R 200; r315] in
  let r317 = Sub [r312; r316] in
  let r318 = Sub [R 270; r317] in
  let r319 = Sub [S (T T_RBRACKET); R 100] in
  let r320 = Sub [R 368; S (T T_LIDENT); S (T T_COLON); r53; R 270; R 219; R 221] in
  let r321 = Sub [S (T T_RBRACE); R 114] in
  let r322 = Sub [R 270; R 220] in
  let r323 = Sub [S (T T_SEMI); r322] in
  let r324 = Sub [R 270; r323] in
  let r325 = Sub [r53; r324] in
  let r326 = Sub [S (T T_COLON); r325] in
  let r327 = Sub [r15; R 501] in
  let r328 = Sub [r12; R 113] in
  let r329 = Sub [r12; R 205] in
  let r330 = Sub [r12; R 203] in
  let r331 = Sub [r12; R 202] in
  let r332 = Sub [R 276; R 248] in
  let r333 = Sub [r257; r332] in
  let r334 = Sub [R 511; r333] in
  let r335 = Sub [R 270; r334] in
  let r336 = Sub [S (T T_RPAREN); R 619] in
  let r337 = Sub [S (N N_module_expr); r336] in
  let r338 = Sub [R 270; r337] in
  let r339 = Sub [S (T T_RPAREN); R 620] in
  let r340 = Sub [S (T T_RPAREN); R 605] in
  let r341 = Sub [S (T T_RPAREN); R 457] in
  let r342 = Sub [S (T T_RPAREN); R 455] in
  let r343 = Sub [S (T T_RPAREN); R 456] in
  let r344 = Sub [R 276; R 365] in
  let r345 = Sub [R 442; r344] in
  let r346 = Sub [r34; r345] in
  let r347 = Sub [R 270; r346] in
  let r348 = Sub [R 179; r347] in
  let r349 = Sub [R 276; R 732] in
  let r350 = Sub [r304; r349] in
  let r351 = Sub [r76; r350] in
  let r352 = Sub [R 270; r351] in
  let r353 = Sub [R 266; R 733] in
  let r354 = Sub [R 276; r353] in
  let r355 = Sub [r304; r354] in
  let r356 = Sub [R 266; R 267] in
  let r357 = Sub [R 276; r356] in
  let r358 = Sub [r304; r357] in
  let r359 = Sub [r76; r358] in
  let r360 = Sub [S (T T_RBRACKET); R 217] in
  let r361 = Sub [r8; r360] in
  let r362 = Sub [S (T T_RBRACKET); R 185] in
  let r363 = Sub [r8; r362] in
  let r364 = Sub [R 276; R 738] in
  let r365 = Sub [S (N N_module_expr); r364] in
  let r366 = Sub [R 270; r365] in
  let r367 = Sub [R 276; R 503] in
  let r368 = Sub [S (T T_STRING); R 378; r367] in
  let r369 = Sub [S (T T_EQUAL); r368] in
  let r370 = Sub [r17; r369] in
  let r371 = Sub [S (T T_COLON); r370] in
  let r372 = Sub [r11; r371] in
  let r373 = Sub [R 270; r372] in
  let r374 = Sub [r16; R 499] in
  let r375 = Sub [S (T T_TRUE); R 103; R 110] in
  let r376 = Sub [R 276; R 718] in
  let r377 = Sub [R 270; r376] in
  let r378 = Sub [r375; r377] in
  let r379 = Sub [R 276; R 576] in
  let r380 = Sub [R 270; r379] in
  let r381 = Sub [R 276; R 396] in
  let r382 = Sub [r124; r381] in
  let r383 = Sub [R 270; r382] in
  let r384 = Sub [R 276; R 397] in
  let r385 = Sub [r124; r384] in
  let r386 = Sub [R 270; r385] in
  let r387 = Sub [R 276; R 366] in
  let r388 = Sub [S (N N_module_type); r387] in
  let r389 = Sub [S (N N_module_type); R 342] in
  let r390 = Sub [S (T T_COLON); r389] in
  let r391 = Sub [R 276; R 586] in
  let r392 = Sub [r390; r391] in
  let r393 = Sub [r76; r392] in
  let r394 = Sub [R 270; r393] in
  let r395 = Sub [R 276; R 355] in
  let r396 = Sub [R 268; R 589] in
  let r397 = Sub [R 276; r396] in
  let r398 = Sub [S (N N_module_type); r397] in
  let r399 = Sub [S (T T_COLON); r398] in
  let r400 = Sub [R 268; R 269] in
  let r401 = Sub [R 276; r400] in
  let r402 = Sub [S (N N_module_type); r401] in
  let r403 = Sub [S (T T_COLON); r402] in
  let r404 = Sub [r76; r403] in
  let r405 = Sub [R 276; R 587] in
  let r406 = Sub [R 276; R 593] in
  let r407 = Sub [S (N N_module_type); r406] in
  let r408 = Sub [R 270; r407] in
  let r409 = Sub [R 200; r380] in
  let r410 = Sub [r312; r409] in
  let r411 = Sub [R 270; r410] in
  let r412 = Sub [R 179; r411] in
  let r413 = Sub [R 262; R 594] in
  let r414 = Sub [R 276; r413] in
  let r415 = Sub [S (N N_class_type); r414] in
  let r416 = Sub [S (T T_COLON); r415] in
  let r417 = Sub [S (T T_LIDENT); r416] in
  let r418 = Sub [R 186; r417] in
  let r419 = Sub [R 789; r418] in
  let r420 = Sub [R 270; r419] in
  let r421 = Sub [r123; R 78] in
  let r422 = Sub [R 264; R 94] in
  let r423 = Sub [R 276; r422] in
  let r424 = Sub [r421; r423] in
  let r425 = Sub [S (T T_EQUAL); r424] in
  let r426 = Sub [S (T T_LIDENT); r425] in
  let r427 = Sub [R 186; r426] in
  let r428 = Sub [R 789; r427] in
  let r429 = Sub [R 270; r428] in
  let r430 = Sub [S (T T_RBRACKET); R 187] in
  let r431 = Sub [S (T T_END); R 81] in
  let r432 = Sub [R 285; r431] in
  let r433 = Sub [R 70; r432] in
  let r434 = Sub [S (T T_RPAREN); R 71] in
  let r435 = Sub [R 276; R 73] in
  let r436 = Sub [r16; r435] in
  let r437 = Sub [S (T T_COLON); r436] in
  let r438 = Sub [S (T T_LIDENT); r437] in
  let r439 = Sub [R 370; r438] in
  let r440 = Sub [R 276; R 74] in
  let r441 = Sub [r17; r440] in
  let r442 = Sub [S (T T_COLON); r441] in
  let r443 = Sub [S (T T_LIDENT); r442] in
  let r444 = Sub [R 506; r443] in
  let r445 = Sub [R 276; R 72] in
  let r446 = Sub [r421; r445] in
  let r447 = Sub [r421; R 83] in
  let r448 = Sub [S (T T_IN); r447] in
  let r449 = Sub [r186; r448] in
  let r450 = Sub [R 270; r449] in
  let r451 = Sub [r421; R 84] in
  let r452 = Sub [S (T T_IN); r451] in
  let r453 = Sub [r186; r452] in
  let r454 = Sub [r16; R 546] in
  let r455 = Sub [r123; R 79] in
  let r456 = Sub [S (T T_RBRACKET); r455] in
  let r457 = Sub [r454; r456] in
  let r458 = Sub [r16; R 111] in
  let r459 = Sub [S (T T_EQUAL); r458] in
  let r460 = Sub [r16; r459] in
  let r461 = Sub [R 276; R 75] in
  let r462 = Sub [r460; r461] in
  let r463 = Sub [R 264; R 265] in
  let r464 = Sub [R 276; r463] in
  let r465 = Sub [r421; r464] in
  let r466 = Sub [S (T T_EQUAL); r465] in
  let r467 = Sub [S (T T_LIDENT); r466] in
  let r468 = Sub [R 186; r467] in
  let r469 = Sub [R 789; r468] in
  let r470 = Sub [S (N N_class_type); R 92] in
  let r471 = Sub [S (T T_MINUSGREATER); r470] in
  let r472 = Sub [r13; r471] in
  let r473 = Sub [S (N N_class_type); R 93] in
  let r474 = Sub [S (N N_class_type); R 91] in
  let r475 = Sub [S (T T_MINUSGREATER); r474] in
  let r476 = Sub [R 262; R 263] in
  let r477 = Sub [R 276; r476] in
  let r478 = Sub [S (N N_class_type); r477] in
  let r479 = Sub [S (T T_COLON); r478] in
  let r480 = Sub [S (T T_LIDENT); r479] in
  let r481 = Sub [R 186; r480] in
  let r482 = Sub [R 789; r481] in
  let r483 = Sub [R 272; R 273] in
  let r484 = Sub [R 276; r483] in
  let r485 = Sub [R 527; r484] in
  let r486 = Sub [R 759; r485] in
  let r487 = Sub [S (T T_LIDENT); r486] in
  let r488 = Sub [R 764; r487] in
  let r489 = Sub [R 274; R 275] in
  let r490 = Sub [R 276; r489] in
  let r491 = Sub [R 527; r490] in
  let r492 = Sub [r47; r491] in
  let r493 = Sub [S (T T_COLONEQUAL); r492] in
  let r494 = Sub [S (T T_LIDENT); r493] in
  let r495 = Sub [R 764; r494] in
  let r496 = Sub [S (T T_RBRACE); R 390] in
  let r497 = Sub [R 270; R 206] in
  let r498 = Sub [R 200; r497] in
  let r499 = Sub [r312; r498] in
  let r500 = Sub [S (T T_RBRACE); R 393] in
  let r501 = Sub [R 270; R 207] in
  let r502 = Sub [R 200; r501] in
  let r503 = Sub [S (T T_RBRACE); R 392] in
  let r504 = Sub [S (N N_class_expr); R 61] in
  let r505 = Sub [S (T T_EQUAL); r504] in
  let r506 = Sub [R 260; R 736] in
  let r507 = Sub [R 276; r506] in
  let r508 = Sub [r505; r507] in
  let r509 = Sub [S (T T_LIDENT); r508] in
  let r510 = Sub [R 186; r509] in
  let r511 = Sub [R 789; r510] in
  let r512 = Sub [R 270; r511] in
  let r513 = Sub [S (T T_END); R 89] in
  let r514 = Sub [R 287; r513] in
  let r515 = Sub [R 69; r514] in
  let r516 = Sub [r0; R 784] in
  let r517 = Sub [S (T T_EQUAL); r516] in
  let r518 = Sub [S (T T_LIDENT); r517] in
  let r519 = Sub [R 368; r518] in
  let r520 = Sub [R 276; R 55] in
  let r521 = Sub [r0; R 785] in
  let r522 = Sub [S (T T_EQUAL); r521] in
  let r523 = Sub [S (T T_LIDENT); r522] in
  let r524 = Sub [R 368; r523] in
  let r525 = Sub [r0; R 787] in
  let r526 = Sub [r16; R 783] in
  let r527 = Sub [S (T T_COLON); r526] in
  let r528 = Sub [r0; R 786] in
  let r529 = Sub [r255; R 311] in
  let r530 = Sub [S (T T_LIDENT); r529] in
  let r531 = Sub [R 504; r530] in
  let r532 = Sub [R 276; R 56] in
  let r533 = Sub [r255; R 312] in
  let r534 = Sub [S (T T_LIDENT); r533] in
  let r535 = Sub [R 504; r534] in
  let r536 = Sub [r0; R 314] in
  let r537 = Sub [S (T T_EQUAL); r536] in
  let r538 = Sub [r0; R 316] in
  let r539 = Sub [S (T T_EQUAL); r538] in
  let r540 = Sub [r16; r539] in
  let r541 = Sub [S (T T_DOT); r540] in
  let r542 = Sub [r17; R 310] in
  let r543 = Sub [S (T T_COLON); r542] in
  let r544 = Sub [r0; R 313] in
  let r545 = Sub [S (T T_EQUAL); r544] in
  let r546 = Sub [r0; R 315] in
  let r547 = Sub [S (T T_EQUAL); r546] in
  let r548 = Sub [r16; r547] in
  let r549 = Sub [S (T T_DOT); r548] in
  let r550 = Sub [R 276; R 58] in
  let r551 = Sub [r0; r550] in
  let r552 = Sub [R 276; R 53] in
  let r553 = Sub [R 436; r552] in
  let r554 = Sub [S (N N_class_expr); r553] in
  let r555 = Sub [R 276; R 54] in
  let r556 = Sub [R 436; r555] in
  let r557 = Sub [S (N N_class_expr); r556] in
  let r558 = Sub [S (T T_RPAREN); R 85] in
  let r559 = Sub [S (N N_class_expr); R 48] in
  let r560 = Sub [S (T T_IN); r559] in
  let r561 = Sub [r186; r560] in
  let r562 = Sub [R 270; r561] in
  let r563 = Sub [S (N N_class_expr); R 49] in
  let r564 = Sub [S (T T_IN); r563] in
  let r565 = Sub [r186; r564] in
  let r566 = Sub [r96; R 87] in
  let r567 = Sub [S (T T_RBRACKET); r566] in
  let r568 = Sub [S (N N_class_expr); R 64] in
  let r569 = Sub [S (T T_MINUSGREATER); r568] in
  let r570 = Sub [r219; r569; R 46] in
  let r571 = Sub [S (N N_class_expr); R 47] in
  let r572 = Sub [R 276; R 250] in
  let r573 = Sub [r257; r572] in
  let r574 = Sub [S (T T_RPAREN); R 88] in
  let r575 = Sub [R 276; R 57] in
  let r576 = Sub [r460; r575] in
  let r577 = Sub [S (N N_class_expr); R 62] in
  let r578 = Sub [S (T T_EQUAL); r577] in
  let r579 = Sub [R 260; R 261] in
  let r580 = Sub [R 276; r579] in
  let r581 = Sub [r505; r580] in
  let r582 = Sub [S (T T_LIDENT); r581] in
  let r583 = Sub [R 186; r582] in
  let r584 = Sub [R 789; r583] in
  let r585 = Sub [R 179; r335] in
  let r586 = Sub [R 281; R 723] in
  let r587 = Sub [R 281; R 283] in
  let r588 = Sub [S (T T_RPAREN); R 68] in
  let r589 = Sub [r312; r502] in
  let r590 = Sub [R 276; R 730] in
  let r591 = Sub [r589; R 518; r590] in
  let r592 = Sub [R 504; r591] in
  let r593 = Sub [S (T T_PLUSEQ); r592] in
  let r594 = Sub [R 270; R 183] in
  let r595 = Sub [R 270; R 184] in
  let r596 = Sub [r139; R 28] in
  let r597 = Sub [S (T T_RBRACE); R 391] in
  let r598 = Sub [R 276; R 208] in
  let r599 = Sub [R 527; r598] in
  let r600 = Sub [R 276; R 584] in
  let r601 = Sub [r589; R 524; r600] in
  let r602 = Sub [R 504; r601] in
  let r603 = Sub [S (T T_PLUSEQ); r602] in
  let r604 = Sub [S (T T_RPAREN); R 101] in
  let r605 = Sub [S (T T_DOT); r126] in
  let r606 = Sub [S (T T_RPAREN); R 323] in
  let r607 = Sub [S (T T_SEMISEMI); R 750] in
  let r608 = Sub [R 291; R 293] in
  let r609 = Sub [S (T T_EOF); R 778] in
  let r610 = Sub [R 291; r609] in
  let r611 = Sub [R 759; r59] in
  let r612 = Sub [S (T T_LIDENT); r611] in
  let r613 = Sub [R 764; r612] in
  let r614 = Sub [R 270; r613] in
  let r615 = Sub [R 179; r614] in
  let r616 = Sub [r139; r603] in
  let r617 = Sub [R 764; r616] in
  let r618 = Sub [R 270; r617] in
  let r619 = Sub [r139; r593] in
  let r620 = Sub [R 764; r619] in
  let r621 = Sub [R 270; r620] in
  let r622 = Sub [S (T T_LIDENT); R 318] in
  let r623 = Sub [S (T T_LBRACKET); r150] in
  let r624 = Sub [r34; R 326] in
  let r625 = Sub [S (T T_TYPE); r348] in
  let r626 = Sub [S (T T_EQUAL); r378] in
  let r627 = Sub [r312; r626] in
  let r628 = Sub [R 270; r627] in
  let r629 = Sub [S (T T_COLONEQUAL); r388] in
  let r630 = Sub [r34; r629] in
  let r631 = Sub [R 270; r630] in
  function
  | 0 | 113 | 164 | 1685 | 1689 | 1707 | 1711 | 1715 | 1719 | 1723 | 1727 | 1731 | 1735 | 1739 | 1743 | 1749 | 1769 -> Nothing
  | 1 -> One [R 179; r5]
  | 2 -> One [r6; R 180]
  | 3 -> One [R 716]
  | 4 -> One [R 715]
  | 5 -> One [R 714]
  | 6 -> One [R 713]
  | 7 -> One [R 712]
  | 8 -> One [R 667]
  | 9 -> One [R 711]
  | 10 -> One [R 710]
  | 11 -> One [R 709]
  | 12 -> One [R 708]
  | 13 -> One [R 707]
  | 14 -> One [R 706]
  | 15 -> One [R 705]
  | 16 -> One [R 704]
  | 17 -> One [R 703]
  | 18 -> One [R 702]
  | 19 -> One [R 701]
  | 20 -> One [R 700]
  | 21 -> One [R 699]
  | 22 -> One [R 698]
  | 23 -> One [R 697]
  | 24 -> One [R 696]
  | 25 -> One [R 695]
  | 26 -> One [R 694]
  | 27 -> One [R 693]
  | 28 -> One [R 666]
  | 29 -> One [R 692]
  | 30 -> One [R 691]
  | 31 -> One [R 690]
  | 32 -> One [R 689]
  | 33 -> One [R 688]
  | 34 -> One [R 687]
  | 35 -> One [R 686]
  | 36 -> One [R 685]
  | 37 -> One [R 684]
  | 38 -> One [R 683]
  | 39 -> One [R 682]
  | 40 -> One [R 681]
  | 41 -> One [R 680]
  | 42 -> One [R 679]
  | 43 -> One [R 678]
  | 44 -> One [R 677]
  | 45 -> One [R 676]
  | 46 -> One [R 675]
  | 47 -> One [R 674]
  | 48 -> One [R 673]
  | 49 -> One [R 672]
  | 50 -> One [R 671]
  | 51 -> One [R 670]
  | 52 -> One [R 669]
  | 53 -> One [R 668]
  | 54 -> One [R 42]
  | 55 -> One [r6; R 43]
  | 56 -> One [R 43]
  | 57 -> One [R 180]
  | 58 -> One [r5]
  | 59 -> One [r6; r10]
  | 60 -> One [r10]
  | 61 -> One [R 179; r22]
  | 62 -> One [r22]
  | 63 -> One [r21]
  | 64 -> One [r24]
  | 65 -> One [R 420]
  | 66 -> One [R 419]
  | 67 -> One [R 398]
  | 68 -> One [R 416]
  | 69 -> One [R 415]
  | 70 -> One [R 414]
  | 71 -> One [R 421]
  | 72 -> One [R 425]
  | 73 -> One [R 418]
  | 74 -> One [R 417]
  | 75 -> One [R 399]
  | 76 -> One [R 423]
  | 77 -> One [R 413]
  | 78 -> One [R 412]
  | 79 -> One [R 411]
  | 80 -> One [R 410]
  | 81 -> One [R 409]
  | 82 -> One [R 407]
  | 83 -> One [R 424]
  | 84 -> One [R 422]
  | 85 -> One [S (T T_LPAREN); r26]
  | 86 -> One [r26]
  | 87 -> One [S (T T_DOTDOT); R 215]
  | 88 -> One [R 215]
  | 89 -> One [r25]
  | 90 -> One [R 401]
  | 91 -> One [R 402]
  | 92 -> One [R 214; r27]
  | 93 -> One [r27]
  | 94 -> One [R 403]
  | 95 -> One [R 404]
  | 96 -> One [R 214; r28]
  | 97 -> One [r28]
  | 98 -> One [R 405]
  | 99 -> One [R 406]
  | 100 -> One [R 429]
  | 101 -> One [R 426]
  | 102 -> One [R 408]
  | 103 -> One [R 400]
  | 104 -> One [R 427]
  | 105 -> One [R 428]
  | 106 -> One [r23]
  | 107 -> One [R 779]
  | 108 -> One [R 780]
  | 109 -> One [r20]
  | 110 -> One [r19]
  | 111 -> One [R 25]
  | 112 -> One [R 335]
  | 114 -> One [R 336]
  | 115 -> One [R 182]
  | 117 -> One [R 211]
  | 118 -> One [R 212]
  | 120 -> One [S (T T_LIDENT); r29]
  | 121 -> One [r29]
  | 122 -> One [R 451]
  | 123 -> One [R 450]
  | 124 -> One [S (T T_MODULE); r33]
  | 125 -> One [r35]
  | 126 -> One [R 24]
  | 127 -> One [r33]
  | 128 -> One [r32]
  | 129 -> One [r31]
  | 130 -> One [R 335]
  | 131 -> One [R 270; r38]
  | 132 -> One [r38]
  | 136 -> One [R 770]
  | 137 -> One [R 773]
  | 138 -> One [R 764; r42]
  | 139 -> One [R 771]
  | 140 -> One [R 775]
  | 141 -> One [r45; r46]
  | 142 -> One [R 772]
  | 143 -> One [R 774]
  | 144 -> One [R 776]
  | 145 -> One [r43]
  | 146 -> One [R 768]
  | 147 -> One [r34; R 767]
  | 148 -> One [R 767]
  | 149 -> One [R 763]
  | 150 -> One [R 548]
  | 151 -> One [r46]
  | 152 -> One [R 766]
  | 153 -> One [r44; R 549]
  | 154 -> One [R 549]
  | 155 -> One [r42]
  | 156 -> One [r41]
  | 157 -> One [r47; R 760]
  | 158 -> One [R 104]
  | 159 -> One [R 103]
  | 160 -> One [S (T T_DOTDOT); R 387]
  | 161 -> One [r49]
  | 162 -> One [R 101]
  | 165 -> One [R 762]
  | 166 -> One [r52]
  | 167 -> One [R 317]
  | 168 -> One [S (T T_GREATER); R 30]
  | 169 -> One [S (T T_COLON); r55]
  | 170 -> One [r55]
  | 171 -> One [r6; r57]
  | 172 -> One [r57]
  | 173 -> One [R 636]
  | 174 -> One [R 329]
  | 180 -> One [r59]
  | 181 -> One [r58]
  | 182 -> One [r6; r61]
  | 183 -> One [r61]
  | 184 -> One [R 179; r69]
  | 185 -> One [r69]
  | 186 -> One [r68]
  | 187 -> One [R 98]
  | 188 -> One [r70; R 626]
  | 189 -> One [R 179; r74]
  | 190 -> One [r74]
  | 191 -> One [r73]
  | 192 -> One [S (N N_pattern); r75]
  | 193 -> One [R 654]
  | 194 -> One [S (T T_INT); R 599]
  | 195 -> One [R 599]
  | 196 -> One [R 600]
  | 197 -> One [S (T T_INT); R 597]
  | 198 -> One [R 597]
  | 199 -> One [R 598]
  | 201 -> One [R 414]
  | 202 -> One [R 179; r79]
  | 203 -> One [r79]
  | 204 -> One [r78]
  | 205 -> One [R 354]
  | 206 -> One [R 353]
  | 207 -> One [r77]
  | 208 -> One [R 652]
  | 209 -> One [S (N N_module_type); r80]
  | 210 -> One [S (T T_TYPE); r83]
  | 211 -> One [r83]
  | 212 -> One [r82]
  | 213 -> One [r81]
  | 214 -> One [R 352]
  | 215 -> One [R 270; r85]
  | 216 -> One [r85]
  | 217 -> One [R 281; R 282]
  | 218 -> One [R 218]
  | 219 -> One [R 16]
  | 220 -> One [R 15]
  | 221 -> One [R 179; r88]
  | 222 -> One [R 179; r91]
  | 223 -> One [r91]
  | 224 -> One [r90]
  | 225 -> One [S (N N_module_expr); r92]
  | 226 -> One [R 270; r94]
  | 227 -> One [r94]
  | 228 -> One [R 179; r98]
  | 229 -> One [r98]
  | 230 -> One [r97]
  | 231 -> One [R 327]
  | 232 -> One [r100]
  | 233 -> One [r99]
  | 234 -> One [R 330]
  | 235 -> One [R 328]
  | 236 -> One [R 338]
  | 237 -> One [R 66]
  | 238 -> One [R 618]
  | 239 -> One [R 270; R 271]
  | 240 -> One [R 271]
  | 241 -> One [R 740]
  | 242 -> One [R 739]
  | 243 -> One [R 179; r104]
  | 244 -> One [r104]
  | 245 -> One [r103]
  | 247 -> One [R 398]
  | 248 -> One [S (T T_BARRBRACKET); R 641]
  | 250 -> One [r105]
  | 251 -> One [r106; R 258; r108]
  | 252 -> One [S (T T_BARRBRACKET); R 604]
  | 254 -> One [R 100]
  | 255 -> One [r109; r111; r112]
  | 256 -> One [R 226]
  | 257 -> One [r112]
  | 258 -> One [R 601]
  | 259 -> One [r111]
  | 260 -> One [r16; R 439]
  | 261 -> One [R 432; r116]
  | 262 -> One [R 433]
  | 263 -> One [r116]
  | 264 -> One [S (T T_RBRACKET); R 38]
  | 265 -> One [R 38]
  | 266 -> One [r114; r117]
  | 267 -> One [r119; r120; r121]
  | 268 -> One [r123; R 31]
  | 269 -> One [R 317]
  | 270 -> One [R 333]
  | 272 -> One [r124; r125]
  | 273 -> One [r125]
  | 274 -> One [R 334]
  | 275 -> One [r126]
  | 276 -> One [R 337]
  | 278 -> One [R 318]
  | 279 -> One [R 95]
  | 280 -> One [R 31]
  | 281 -> One [r114; r127]
  | 282 -> One [r118]
  | 283 -> One [R 375]
  | 284 -> One [R 26]
  | 285 -> One [R 194]
  | 286 -> One [r14; R 197]
  | 287 -> One [R 755]
  | 288 -> One [r12; R 556]
  | 289 -> One [R 761]
  | 290 -> One [R 41]
  | 291 -> One [R 556]
  | 292 -> One [r123; R 32]
  | 293 -> One [R 32]
  | 294 -> One [R 27]
  | 295 -> One [r13; r129]
  | 296 -> One [r129]
  | 297 -> One [r128]
  | 298 -> One [R 195]
  | 299 -> One [R 754]
  | 300 -> One [r12; R 557]
  | 301 -> One [R 557]
  | 302 -> One [R 197]
  | 303 -> One [R 558]
  | 304 -> One [R 544]
  | 305 -> One [r127]
  | 306 -> One [R 35]
  | 307 -> One [r113; R 545]
  | 308 -> One [R 545]
  | 309 -> One [r120]
  | 310 -> One [R 431; r131]
  | 311 -> One [R 430]
  | 312 -> One [r131]
  | 313 -> One [r130]
  | 314 -> One [r15; R 541]
  | 315 -> One [R 17]
  | 316 -> One [R 541]
  | 317 -> One [S (T T_QUOTE); r132]
  | 318 -> One [r132]
  | 319 -> One [R 18]
  | 320 -> One [R 741]
  | 321 -> One [R 540]
  | 322 -> One [R 742]
  | 323 -> One [R 559]
  | 324 -> One [R 118]
  | 325 -> One [R 117]
  | 326 -> One [r121]
  | 327 -> One [R 34]
  | 328 -> One [S (T T_BAR); r134]
  | 329 -> One [r134]
  | 330 -> One [r133]
  | 331 -> One [R 36]
  | 332 -> One [r117]
  | 333 -> One [R 37]
  | 334 -> One [r115]
  | 335 -> One [R 39]
  | 336 -> One [r119; R 533; r135]
  | 337 -> One [r135]
  | 338 -> One [R 40]
  | 339 -> One [R 534]
  | 340 -> One [R 533]
  | 341 -> One [R 439]
  | 342 -> One [r110]
  | 343 -> One [S (N N_pattern); R 445]
  | 344 -> One [R 179; r138]
  | 345 -> One [r138]
  | 346 -> One [r137]
  | 347 -> One [R 96]
  | 348 -> One [r139; R 659]
  | 349 -> One [R 659]
  | 350 -> One [R 99]
  | 351 -> One [R 102]
  | 352 -> One [R 97]
  | 353 -> One [R 648]
  | 354 -> One [R 781]
  | 355 -> One [R 649]
  | 356 -> One [R 484]
  | 357 -> One [R 651]
  | 358 -> One [R 655]
  | 359 -> One [S (T T_PLUS); S (T T_FLOAT); R 600; R 656]
  | 360 -> One [R 656]
  | 361 -> One [R 596]
  | 362 -> One [R 658]
  | 365 -> One [S (T T_RPAREN); R 662]
  | 366 -> One [R 662]
  | 367 -> One [R 179; r141]
  | 368 -> One [r141]
  | 369 -> One [r140]
  | 370 -> One [R 480]
  | 371 -> One [R 471]
  | 372 -> One [R 473]
  | 373 -> One [S (N N_pattern); R 476]
  | 374 -> One [R 476]
  | 375 -> One [S (N N_pattern); R 469]
  | 376 -> One [R 469]
  | 377 -> One [R 470]
  | 379 -> One [R 483]
  | 380 -> One [R 665]
  | 382 -> One [r143]
  | 383 -> One [r144; r146]
  | 384 -> One [R 376]
  | 385 -> One [R 377]
  | 386 -> One [r146]
  | 387 -> One [r145]
  | 388 -> One [R 482]
  | 389 -> One [R 657]
  | 390 -> One [R 110]
  | 391 -> One [R 417]
  | 392 -> One [r147]
  | 393 -> One [R 109]
  | 394 -> One [r142]
  | 395 -> One [R 650]
  | 396 -> One [S (N N_pattern); R 477]
  | 397 -> One [R 477]
  | 398 -> One [r16; r148]
  | 399 -> One [r148]
  | 400 -> One [R 664]
  | 401 -> One [S (N N_pattern); R 474]
  | 402 -> One [R 474]
  | 403 -> One [r11; R 472]
  | 404 -> One [R 472]
  | 405 -> One [R 481]
  | 406 -> One [R 475]
  | 407 -> One [r149]
  | 408 -> One [R 108]
  | 409 -> One [S (T T_RPAREN); R 663]
  | 410 -> One [R 663]
  | 411 -> One [r150]
  | 412 -> One [R 661]
  | 413 -> One [r151]
  | 414 -> One [R 602]
  | 415 -> One [R 566]
  | 416 -> One [R 567]
  | 417 -> One [R 568]
  | 418 -> One [R 660]
  | 419 -> One [R 445]
  | 420 -> One [R 296]
  | 421 -> One [R 297]
  | 422 -> One [R 434; R 298]
  | 423 -> One [R 435]
  | 424 -> One [R 298]
  | 425 -> One [R 299]
  | 426 -> One [R 604]
  | 427 -> One [S (T T_BARRBRACKET); R 603]
  | 428 -> One [R 603]
  | 429 -> One [R 255]
  | 430 -> One [r152]
  | 431 -> One [r153; r154]
  | 432 -> One [R 224]
  | 433 -> One [r16; R 225]
  | 434 -> One [R 225]
  | 435 -> One [r154]
  | 436 -> One [R 237]
  | 437 -> One [R 238]
  | 438 -> One [S (T T_LIDENT); R 234]
  | 439 -> One [r153; r156]
  | 440 -> One [r156]
  | 441 -> One [r0; R 447]
  | 443 -> One [r161]
  | 444 -> One [R 179; r165]
  | 445 -> One [r165]
  | 446 -> One [r164]
  | 447 -> One [R 270; r170]
  | 448 -> One [r170]
  | 449 -> One [r166]
  | 450 -> One [R 198]
  | 451 -> One [S (T T_COLON); r172]
  | 452 -> One [r172]
  | 453 -> One [S (N N_module_type); r173]
  | 454 -> One [R 270; r176]
  | 455 -> One [r176]
  | 456 -> One [r175]
  | 457 -> One [r174]
  | 458 -> One [R 361]
  | 459 -> One [R 357]
  | 460 -> One [r179; R 542; R 363]
  | 461 -> One [R 764; r182]
  | 462 -> One [r182]
  | 463 -> One [r181]
  | 464 -> One [R 803]
  | 465 -> One [R 804]
  | 466 -> One [r180]
  | 467 -> One [R 798]
  | 468 -> One [r15; r183]
  | 469 -> One [r183]
  | 470 -> One [R 797]
  | 471 -> One [r16; r185]
  | 472 -> One [r185]
  | 473 -> One [r184]
  | 474 -> One [R 528]
  | 475 -> One [R 765]
  | 476 -> One [r186; r188]
  | 477 -> One [r177; r190]
  | 478 -> One [r190]
  | 479 -> One [r189]
  | 480 -> One [R 801]
  | 481 -> One [R 360]
  | 485 -> One [R 326]
  | 486 -> One [R 367]
  | 487 -> One [R 325]
  | 488 -> One [R 364]
  | 489 -> One [r178]
  | 490 -> One [R 802]
  | 491 -> One [S (N N_module_type); R 362]
  | 492 -> One [R 362]
  | 493 -> One [r188]
  | 494 -> One [r187]
  | 495 -> One [R 799]
  | 496 -> One [r191]
  | 497 -> One [r124; R 800]
  | 498 -> One [R 800]
  | 499 -> One [R 542]
  | 500 -> One [R 363]
  | 501 -> One [r179; R 543]
  | 502 -> One [R 543]
  | 503 -> One [R 530]
  | 504 -> One [R 529]
  | 505 -> One [r173]
  | 506 -> One [R 359]
  | 507 -> One [r171]
  | 508 -> One [R 199]
  | 509 -> One [r169]
  | 510 -> One [r168]
  | 511 -> One [R 346]
  | 512 -> One [R 345]
  | 513 -> One [S (T T_RPAREN); R 350]
  | 514 -> One [R 350]
  | 515 -> One [r92]
  | 516 -> One [R 453]
  | 517 -> One [S (N N_module_type); r192]
  | 518 -> One [r192]
  | 519 -> One [R 452]
  | 520 -> One [R 349]
  | 521 -> One [R 347]
  | 522 -> One [R 348]
  | 523 -> One [R 351]
  | 524 -> One [r163]
  | 525 -> One [r162]
  | 527 -> One [S (T T_GREATERRBRACE); R 629]
  | 528 -> One [r193]
  | 529 -> One [S (N N_expr); R 441]
  | 530 -> One [r197; r198]
  | 531 -> One [R 780]
  | 532 -> One [R 179; r200]
  | 533 -> One [r200]
  | 534 -> One [r199]
  | 535 -> One [R 179; r202]
  | 536 -> One [r202]
  | 537 -> One [r201]
  | 538 -> One [r70; R 627]
  | 539 -> One [R 622]
  | 540 -> One [R 331]
  | 541 -> One [R 627]
  | 542 -> One [R 625]
  | 545 -> One [r203]
  | 546 -> One [R 637]
  | 547 -> One [R 415]
  | 548 -> One [R 414]
  | 549 -> One [R 179; r208]
  | 550 -> One [r208]
  | 551 -> One [r207]
  | 552 -> One [r206]
  | 553 -> One [r205]
  | 554 -> One [r204]
  | 555 -> One [R 647]
  | 556 -> One [R 418]
  | 557 -> One [R 417]
  | 558 -> One [R 399]
  | 559 -> One [R 480]
  | 560 -> One [r16; r210]
  | 561 -> One [r210]
  | 562 -> One [r209]
  | 563 -> One [R 179; r214]
  | 564 -> One [r214]
  | 565 -> One [r213]
  | 566 -> One [R 179; r216]
  | 567 -> One [r216]
  | 568 -> One [r215]
  | 569 -> One [r64; R 538]
  | 570 -> One [r63]
  | 571 -> One [r0; r218]
  | 572 -> One [R 179; r224]
  | 573 -> One [r224]
  | 574 -> One [r223]
  | 575 -> One [S (T T_UNDERSCORE); R 492; R 236]
  | 576 -> One [R 492]
  | 577 -> One [S (N N_pattern); R 252; r226]
  | 578 -> One [R 252]
  | 579 -> One [r16; R 253]
  | 580 -> One [R 253]
  | 581 -> One [r226]
  | 582 -> One [r225]
  | 583 -> One [R 235]
  | 584 -> One [R 491]
  | 585 -> One [R 236]
  | 586 -> One [S (T T_TYPE); r229]
  | 587 -> One [r229]
  | 588 -> One [r228]
  | 589 -> One [r227]
  | 590 -> One [r220]
  | 591 -> One [R 179; r238]
  | 592 -> One [r238]
  | 593 -> One [r237]
  | 594 -> One [r236]
  | 595 -> One [r235]
  | 596 -> One [R 179; r240]
  | 597 -> One [r240]
  | 598 -> One [r239]
  | 599 -> One [R 135]
  | 600 -> One [r70; R 634]
  | 601 -> One [R 634]
  | 602 -> One [r244]
  | 603 -> One [r243]
  | 604 -> One [S (N N_expr); R 162]
  | 605 -> One [R 121]
  | 606 -> One [S (T T_LIDENT); R 229]
  | 607 -> One [S (T T_LIDENT); r247]
  | 608 -> One [r247]
  | 609 -> One [r245]
  | 610 -> One [R 758]
  | 611 -> One [r248]
  | 612 -> One [R 756]
  | 613 -> One [r16; R 757]
  | 614 -> One [R 757]
  | 615 -> One [r246]
  | 616 -> One [R 230]
  | 617 -> One [R 229]
  | 618 -> One [S (T T_LIDENT); R 231]
  | 619 -> One [R 231]
  | 620 -> One [r70; R 232]
  | 621 -> One [R 232]
  | 622 -> One [S (T T_LIDENT); R 633]
  | 623 -> One [R 633]
  | 624 -> One [r249]
  | 625 -> One [r251]
  | 626 -> One [r250]
  | 627 -> One [R 607]
  | 628 -> One [R 138]
  | 629 -> One [S (N N_expr); R 554]
  | 630 -> One [R 625]
  | 631 -> One [R 140]
  | 632 -> One [R 782]
  | 633 -> One [R 635]
  | 634 -> One [R 624]
  | 635 -> One [R 623]
  | 636 -> One [S (T T_IN); r252]
  | 637 -> One [r252]
  | 638 -> One [R 164]
  | 639 -> One [R 572]
  | 640 -> One [S (N N_expr); R 152]
  | 641 -> One [R 152]
  | 642 -> One [S (N N_expr); R 145]
  | 643 -> One [R 145]
  | 644 -> One [R 178]
  | 645 -> One [R 624]
  | 646 -> One [R 139]
  | 647 -> One [S (N N_expr); R 163]
  | 648 -> One [R 163]
  | 649 -> One [S (N N_expr); R 151]
  | 650 -> One [R 151]
  | 651 -> One [R 573]
  | 652 -> One [r6; r253]
  | 653 -> One [r253]
  | 654 -> One [R 575]
  | 655 -> One [R 574]
  | 656 -> One [S (N N_expr); R 148]
  | 657 -> One [R 148]
  | 658 -> One [S (N N_expr); R 153]
  | 659 -> One [R 153]
  | 660 -> One [S (N N_expr); R 144]
  | 661 -> One [R 144]
  | 662 -> One [S (N N_expr); R 147]
  | 663 -> One [R 147]
  | 664 -> One [S (N N_expr); R 146]
  | 665 -> One [R 146]
  | 666 -> One [S (N N_expr); R 157]
  | 667 -> One [R 157]
  | 668 -> One [S (N N_expr); R 150]
  | 669 -> One [R 150]
  | 670 -> One [S (N N_expr); R 149]
  | 671 -> One [R 149]
  | 672 -> One [S (N N_expr); R 155]
  | 673 -> One [R 155]
  | 674 -> One [S (N N_expr); R 143]
  | 675 -> One [R 143]
  | 676 -> One [S (N N_expr); R 142]
  | 677 -> One [R 142]
  | 678 -> One [S (N N_expr); R 166]
  | 679 -> One [R 166]
  | 680 -> One [S (N N_expr); R 141]
  | 681 -> One [R 141]
  | 682 -> One [S (N N_expr); R 156]
  | 683 -> One [R 156]
  | 684 -> One [S (N N_expr); R 154]
  | 685 -> One [R 154]
  | 686 -> One [S (N N_expr); R 158]
  | 687 -> One [R 158]
  | 688 -> One [S (N N_expr); R 159]
  | 689 -> One [R 159]
  | 690 -> One [S (N N_expr); R 160]
  | 691 -> One [R 160]
  | 692 -> One [S (N N_expr); R 555]
  | 693 -> One [R 555]
  | 694 -> One [S (N N_expr); R 161]
  | 695 -> One [R 161]
  | 696 -> One [R 270; r259]
  | 697 -> One [r259]
  | 698 -> One [r256]
  | 699 -> One [S (T T_TYPE); r263]
  | 700 -> One [r263]
  | 701 -> One [r262]
  | 702 -> One [r261]
  | 703 -> One [r136; R 239]
  | 704 -> One [R 239]
  | 705 -> One [r254]
  | 706 -> One [R 719]
  | 707 -> One [S (T T_EQUAL); r264]
  | 708 -> One [r264]
  | 709 -> One [R 189]
  | 710 -> One [R 188]
  | 711 -> One [R 240]
  | 712 -> One [r260; R 720]
  | 713 -> One [R 720]
  | 714 -> One [R 721]
  | 715 -> One [r248]
  | 716 -> One [r144; r268]
  | 717 -> One [r268]
  | 718 -> One [r267]
  | 719 -> One [r266]
  | 720 -> One [r265]
  | 721 -> One [R 245]
  | 722 -> One [S (T T_DOT); r271]
  | 723 -> One [r34; R 536]
  | 724 -> One [R 536]
  | 725 -> One [r271]
  | 726 -> One [r270]
  | 727 -> One [r269]
  | 728 -> One [R 244]
  | 729 -> One [S (T T_EQUAL); r272]
  | 730 -> One [r272]
  | 731 -> One [R 243]
  | 732 -> One [R 242]
  | 733 -> One [R 649]
  | 734 -> One [r16; r274]
  | 735 -> One [r274]
  | 736 -> One [r273]
  | 737 -> One [R 247]
  | 738 -> One [S (T T_EQUAL); r275]
  | 739 -> One [r275]
  | 740 -> One [R 246]
  | 741 -> One [S (N N_pattern); R 479]
  | 742 -> One [R 479]
  | 743 -> One [S (N N_pattern); R 485]
  | 744 -> One [R 485]
  | 745 -> One [S (N N_pattern); R 490]
  | 746 -> One [R 490]
  | 747 -> One [r11; R 488]
  | 748 -> One [R 488]
  | 749 -> One [R 486]
  | 750 -> One [R 487]
  | 751 -> One [R 489]
  | 752 -> One [S (N N_pattern); R 478]
  | 753 -> One [R 478]
  | 754 -> One [R 241]
  | 755 -> One [r258]
  | 756 -> One [R 276; R 277]
  | 757 -> One [R 277]
  | 758 -> One [R 19]
  | 759 -> One [R 249]
  | 760 -> One [R 554]
  | 761 -> One [r277]
  | 762 -> One [r276]
  | 763 -> One [R 609]
  | 764 -> One [r279]
  | 765 -> One [r278]
  | 766 -> One [R 608]
  | 767 -> One [r100]
  | 768 -> One [r282]
  | 769 -> One [r281]
  | 770 -> One [r280]
  | 771 -> One [R 611]
  | 772 -> One [R 560]
  | 773 -> One [R 561]
  | 774 -> One [R 562]
  | 775 -> One [r284]
  | 776 -> One [r283]
  | 777 -> One [R 615]
  | 778 -> One [r286]
  | 779 -> One [r285]
  | 780 -> One [R 613]
  | 781 -> One [R 630]
  | 782 -> One [r70; R 228]
  | 783 -> One [R 228]
  | 784 -> One [r244]
  | 785 -> One [r243]
  | 786 -> One [r242]
  | 787 -> One [R 610]
  | 788 -> One [S (N N_expr); R 172]
  | 789 -> One [R 172]
  | 790 -> One [r288]
  | 791 -> One [r287]
  | 792 -> One [R 614]
  | 793 -> One [S (N N_expr); R 176]
  | 794 -> One [R 176]
  | 795 -> One [r290]
  | 796 -> One [r289]
  | 797 -> One [R 612]
  | 798 -> One [S (N N_expr); R 174]
  | 799 -> One [R 174]
  | 800 -> One [r249]
  | 801 -> One [r251]
  | 802 -> One [r250]
  | 803 -> One [R 607]
  | 804 -> One [S (N N_expr); R 169]
  | 805 -> One [R 169]
  | 806 -> One [r277]
  | 807 -> One [r276]
  | 808 -> One [R 609]
  | 809 -> One [S (N N_expr); R 171]
  | 810 -> One [R 171]
  | 811 -> One [r279]
  | 812 -> One [r278]
  | 813 -> One [R 608]
  | 814 -> One [S (N N_expr); R 170]
  | 815 -> One [R 170]
  | 816 -> One [r100]
  | 817 -> One [r282]
  | 818 -> One [r281]
  | 819 -> One [r280]
  | 820 -> One [R 611]
  | 821 -> One [S (N N_expr); R 173]
  | 822 -> One [R 173]
  | 823 -> One [r284]
  | 824 -> One [r283]
  | 825 -> One [R 615]
  | 826 -> One [S (N N_expr); R 177]
  | 827 -> One [R 177]
  | 828 -> One [r286]
  | 829 -> One [r285]
  | 830 -> One [R 613]
  | 831 -> One [S (N N_expr); R 175]
  | 832 -> One [R 175]
  | 833 -> One [R 630]
  | 834 -> One [S (N N_expr); R 168]
  | 835 -> One [R 168]
  | 836 -> One [R 227]
  | 837 -> One [R 137]
  | 838 -> One [R 532]
  | 839 -> One [R 531]
  | 840 -> One [R 162]
  | 841 -> One [r242]
  | 842 -> One [R 610]
  | 843 -> One [r288]
  | 844 -> One [r287]
  | 845 -> One [R 614]
  | 846 -> One [r290]
  | 847 -> One [r289]
  | 848 -> One [R 612]
  | 849 -> One [r234]
  | 850 -> One [R 119]
  | 851 -> One [R 120]
  | 852 -> One [r233]
  | 853 -> One [r232]
  | 854 -> One [r231]
  | 855 -> One [r230]
  | 856 -> One [R 134]
  | 857 -> One [R 190]
  | 858 -> One [S (T T_TYPE); r293]
  | 859 -> One [r293]
  | 860 -> One [r292]
  | 861 -> One [r291]
  | 862 -> One [r12; r295]
  | 863 -> One [r295]
  | 864 -> One [r294]
  | 865 -> One [R 191]
  | 866 -> One [r221; R 192]
  | 867 -> One [R 192]
  | 868 -> One [R 193]
  | 869 -> One [R 128]
  | 870 -> One [r222]
  | 871 -> One [R 127]
  | 872 -> One [r218]
  | 873 -> One [r217]
  | 874 -> One [R 301]
  | 875 -> One [r62]
  | 876 -> One [R 302]
  | 877 -> One [R 300]
  | 878 -> One [R 538]
  | 879 -> One [R 126]
  | 880 -> One [r64; R 539]
  | 881 -> One [R 539]
  | 882 -> One [R 537]
  | 883 -> One [r212]
  | 884 -> One [r211]
  | 885 -> One [R 132]
  | 886 -> One [S (N N_expr); R 131]
  | 887 -> One [R 131]
  | 888 -> One [R 256]
  | 889 -> One [S (T T_EQUAL); r296]
  | 890 -> One [r296]
  | 891 -> One [R 257]
  | 892 -> One [r108]
  | 893 -> One [r107]
  | 894 -> One [R 165]
  | 895 -> One [r106; R 259]
  | 896 -> One [R 259]
  | 897 -> One [R 258]
  | 898 -> One [R 408]
  | 899 -> One [S (T T_RPAREN); R 631]
  | 900 -> One [R 631]
  | 901 -> One [S (T T_BARRBRACKET); R 643]
  | 902 -> One [R 643]
  | 903 -> One [S (T T_BARRBRACKET); R 642]
  | 904 -> One [R 642]
  | 905 -> One [S (T T_RBRACKET); R 646]
  | 906 -> One [R 646]
  | 907 -> One [S (T T_RBRACKET); R 645]
  | 908 -> One [R 645]
  | 909 -> One [S (T T_LIDENT); r193; r297]
  | 910 -> One [r297]
  | 911 -> One [R 632]
  | 912 -> One [r197; r298]
  | 913 -> One [S (T T_WITH); r299]
  | 914 -> One [r299]
  | 915 -> One [R 514]
  | 916 -> One [r195]
  | 917 -> One [R 449]
  | 918 -> One [r194]
  | 919 -> One [R 569]
  | 920 -> One [R 570]
  | 921 -> One [R 571]
  | 922 -> One [R 513]
  | 923 -> One [r298]
  | 924 -> One [R 639]
  | 925 -> One [r301]
  | 926 -> One [r300]
  | 927 -> One [R 780]
  | 928 -> One [R 332]
  | 929 -> One [R 136]
  | 930 -> One [R 617]
  | 931 -> One [S (T T_END); R 616]
  | 932 -> One [R 616]
  | 933 -> One [r198]
  | 934 -> One [R 638]
  | 935 -> One [R 441]
  | 936 -> One [R 563]
  | 937 -> One [R 564]
  | 938 -> One [R 565]
  | 939 -> One [R 629]
  | 940 -> One [S (T T_GREATERRBRACE); R 628]
  | 941 -> One [R 628]
  | 942 -> One [r302]
  | 943 -> One [R 644]
  | 944 -> One [R 125]
  | 945 -> One [r160]
  | 946 -> One [r159]
  | 947 -> One [r158]
  | 948 -> One [r157]
  | 949 -> One [R 124]
  | 950 -> One [R 179; r309]
  | 951 -> One [r309]
  | 952 -> One [r308]
  | 953 -> One [r307]
  | 954 -> One [r303]
  | 955 -> One [R 339]
  | 956 -> One [S (N N_module_type); r311]
  | 957 -> One [r311]
  | 958 -> One [r310]
  | 959 -> One [R 340]
  | 960 -> One [r306]
  | 961 -> One [r305]
  | 962 -> One [R 122]
  | 963 -> One [r304; R 341]
  | 964 -> One [R 341]
  | 965 -> One [R 179; r318]
  | 966 -> One [r318]
  | 967 -> One [r317]
  | 968 -> One [R 104]
  | 969 -> One [r49]
  | 970 -> One [r48]
  | 971 -> One [R 105]
  | 972 -> One [r319]
  | 973 -> One [r316]
  | 974 -> One [r12; R 112; R 201]
  | 975 -> One [r320; r321]
  | 976 -> One [R 369]
  | 977 -> One [S (T T_LIDENT); r326]
  | 978 -> One [r326]
  | 979 -> One [r325]
  | 980 -> One [S (T T_DOT); r327]
  | 981 -> One [r327]
  | 982 -> One [R 501]
  | 983 -> One [r324]
  | 984 -> One [r323]
  | 985 -> One [r322]
  | 986 -> One [R 220]
  | 987 -> One [R 500]
  | 988 -> One [r321]
  | 989 -> One [R 114]
  | 990 -> One [R 222]
  | 991 -> One [R 223]
  | 992 -> One [R 221]
  | 993 -> One [S (T T_STAR); r328]
  | 994 -> One [r328]
  | 995 -> One [R 113]
  | 996 -> One [R 201]
  | 997 -> One [R 112]
  | 998 -> One [r12; R 204]
  | 999 -> One [S (T T_DOT); r329]
  | 1000 -> One [r329]
  | 1001 -> One [S (T T_MINUSGREATER); r330]
  | 1002 -> One [r330]
  | 1003 -> One [R 203]
  | 1004 -> One [R 205]
  | 1005 -> One [S (T T_MINUSGREATER); r331]
  | 1006 -> One [r331]
  | 1007 -> One [R 202]
  | 1008 -> One [R 204]
  | 1009 -> One [r315]
  | 1010 -> One [r314]
  | 1011 -> One [r313]
  | 1012 -> One [R 123]
  | 1013 -> One [R 106]
  | 1014 -> One [r335]
  | 1015 -> One [r334]
  | 1016 -> One [R 512]
  | 1017 -> One [r333]
  | 1018 -> One [r332]
  | 1019 -> One [R 248]
  | 1020 -> One [R 447]
  | 1021 -> One [r155]
  | 1022 -> One [R 233]
  | 1023 -> One [R 234]
  | 1024 -> One [R 254]
  | 1025 -> One [R 167]
  | 1026 -> One [R 641]
  | 1027 -> One [S (T T_BARRBRACKET); R 640]
  | 1028 -> One [R 640]
  | 1029 -> One [R 626]
  | 1030 -> One [R 179; r338]
  | 1031 -> One [r338]
  | 1032 -> One [r337]
  | 1033 -> One [r336]
  | 1034 -> One [R 619]
  | 1035 -> One [S (N N_module_type); r339]
  | 1036 -> One [r339]
  | 1037 -> One [R 620]
  | 1038 -> One [r340]
  | 1039 -> One [R 605]
  | 1040 -> One [S (T T_RPAREN); R 606]
  | 1041 -> One [R 606]
  | 1042 -> One [r102]
  | 1043 -> One [r101]
  | 1044 -> One [R 129]
  | 1045 -> One [r93]
  | 1046 -> One [R 454]
  | 1047 -> One [S (N N_module_type); r341]
  | 1048 -> One [r341]
  | 1049 -> One [R 457]
  | 1050 -> One [S (N N_module_type); r342]
  | 1051 -> One [r342]
  | 1052 -> One [R 455]
  | 1053 -> One [S (N N_module_type); r343]
  | 1054 -> One [r343]
  | 1055 -> One [R 456]
  | 1056 -> One [r89]
  | 1057 -> One [R 395]
  | 1058 -> One [r88]
  | 1059 -> One [r87]
  | 1060 -> One [r86]
  | 1061 -> One [R 394]
  | 1063 -> One [r348]
  | 1064 -> One [r347]
  | 1065 -> One [r346]
  | 1066 -> One [r345]
  | 1067 -> One [S (N N_module_type); R 443]
  | 1068 -> One [R 443]
  | 1069 -> One [r344]
  | 1070 -> One [R 365]
  | 1071 -> One [r352]
  | 1072 -> One [r351]
  | 1073 -> One [r76; r355]
  | 1074 -> One [r355]
  | 1075 -> One [r354]
  | 1076 -> One [r353]
  | 1077 -> One [R 270; r359]
  | 1078 -> One [r359]
  | 1079 -> One [r358]
  | 1080 -> One [r357]
  | 1081 -> One [r356]
  | 1082 -> One [R 267]
  | 1083 -> One [R 733]
  | 1084 -> One [r350]
  | 1085 -> One [r349]
  | 1086 -> One [R 732]
  | 1087 -> One [r6; r361]
  | 1088 -> One [r361]
  | 1089 -> One [r7]
  | 1090 -> One [R 496]
  | 1091 -> One [r0; R 497]
  | 1092 -> One [R 497]
  | 1093 -> One [r6; r363]
  | 1094 -> One [r363]
  | 1095 -> One [R 179; r366]
  | 1096 -> One [r366]
  | 1097 -> One [r365]
  | 1098 -> One [r364]
  | 1099 -> One [R 738]
  | 1100 -> One [R 179; r373]
  | 1101 -> One [r373]
  | 1102 -> One [r372]
  | 1103 -> One [r371]
  | 1104 -> One [r370]
  | 1105 -> One [S (T T_DOT); r374]
  | 1106 -> One [r374]
  | 1107 -> One [R 499]
  | 1108 -> One [r369]
  | 1109 -> One [r368]
  | 1110 -> One [R 378]
  | 1111 -> One [R 379]
  | 1112 -> One [r367]
  | 1113 -> One [R 503]
  | 1114 -> One [R 498]
  | 1119 -> One [r378]
  | 1121 -> One [R 107]
  | 1122 -> One [r191]
  | 1123 -> One [S (T T_COLONCOLON); r149]
  | 1124 -> One [r377]
  | 1125 -> One [r376]
  | 1126 -> One [R 718]
  | 1127 -> One [r380]
  | 1128 -> One [r379]
  | 1129 -> One [R 576]
  | 1130 -> One [r36; R 494]
  | 1131 -> One [R 278; R 279]
  | 1132 -> One [R 179; r383]
  | 1133 -> One [R 179; r386]
  | 1134 -> One [r386]
  | 1135 -> One [r385]
  | 1136 -> One [r384]
  | 1137 -> One [R 397]
  | 1138 -> One [r383]
  | 1139 -> One [r382]
  | 1140 -> One [r381]
  | 1141 -> One [R 396]
  | 1147 -> One [r388]
  | 1148 -> One [r387]
  | 1149 -> One [R 366]
  | 1150 -> One [r394]
  | 1151 -> One [r393]
  | 1152 -> One [R 353]
  | 1153 -> One [r124; r395]
  | 1154 -> One [r395]
  | 1155 -> One [R 355]
  | 1156 -> One [r76; r399]
  | 1157 -> One [r399]
  | 1158 -> One [r398]
  | 1159 -> One [r397]
  | 1160 -> One [r396]
  | 1161 -> One [R 270; r404]
  | 1162 -> One [r404]
  | 1163 -> One [r403]
  | 1164 -> One [r402]
  | 1165 -> One [r401]
  | 1166 -> One [r400]
  | 1167 -> One [R 269]
  | 1168 -> One [R 589]
  | 1169 -> One [r392]
  | 1170 -> One [r186; r405]
  | 1171 -> One [r405]
  | 1172 -> One [R 587]
  | 1173 -> One [r389]
  | 1174 -> One [R 342]
  | 1175 -> One [r391]
  | 1176 -> One [R 586]
  | 1177 -> One [r390; R 343]
  | 1178 -> One [R 343]
  | 1179 -> One [R 179; r408]
  | 1180 -> One [r408]
  | 1181 -> One [r407]
  | 1182 -> One [r406]
  | 1183 -> One [R 593]
  | 1184 -> One [r412]
  | 1185 -> One [r411]
  | 1186 -> One [r410]
  | 1187 -> One [r409]
  | 1188 -> One [R 179; r420]
  | 1189 -> One [R 179; r429]
  | 1190 -> One [r429]
  | 1191 -> One [r428]
  | 1192 -> One [R 790]
  | 1193 -> One [r427]
  | 1194 -> One [r45; r430]
  | 1195 -> One [r430]
  | 1196 -> One [R 187]
  | 1197 -> One [r426]
  | 1198 -> One [r425]
  | 1199 -> One [r424]
  | 1200 -> One [R 270; r433]
  | 1201 -> One [r433]
  | 1202 -> One [r16; r434]
  | 1203 -> One [r434]
  | 1204 -> One [R 71]
  | 1205 -> One [r432]
  | 1206 -> One [R 270; r439]
  | 1207 -> One [r439]
  | 1208 -> One [R 372]
  | 1209 -> One [R 374]
  | 1210 -> One [R 371]
  | 1211 -> One [R 373]
  | 1212 -> One [r438]
  | 1213 -> One [r437]
  | 1214 -> One [r436]
  | 1215 -> One [r435]
  | 1216 -> One [R 73]
  | 1217 -> One [R 270; r444]
  | 1218 -> One [r444]
  | 1219 -> One [R 508]
  | 1220 -> One [R 510]
  | 1221 -> One [R 507]
  | 1222 -> One [R 509]
  | 1223 -> One [r443]
  | 1224 -> One [r442]
  | 1225 -> One [r441]
  | 1226 -> One [r440]
  | 1227 -> One [R 74]
  | 1228 -> One [R 270; r446]
  | 1229 -> One [r446]
  | 1230 -> One [S (T T_OPEN); r450]
  | 1231 -> One [r450]
  | 1232 -> One [R 270; r453]
  | 1233 -> One [r453]
  | 1234 -> One [r452]
  | 1235 -> One [r451]
  | 1236 -> One [r457]
  | 1237 -> One [r456]
  | 1238 -> One [r455]
  | 1239 -> One [R 79]
  | 1240 -> One [r16; R 547]
  | 1241 -> One [R 547]
  | 1242 -> One [R 546]
  | 1243 -> One [R 80]
  | 1244 -> One [R 78]
  | 1245 -> One [R 84]
  | 1246 -> One [R 82]
  | 1247 -> One [r449]
  | 1248 -> One [r448]
  | 1249 -> One [r447]
  | 1250 -> One [R 83]
  | 1251 -> One [r445]
  | 1252 -> One [R 72]
  | 1253 -> One [R 270; r462]
  | 1254 -> One [r462]
  | 1255 -> One [r459]
  | 1256 -> One [r458]
  | 1257 -> One [R 111]
  | 1258 -> One [r461]
  | 1259 -> One [R 75]
  | 1260 -> One [r431]
  | 1261 -> One [R 81]
  | 1262 -> One [R 276; R 76]
  | 1263 -> One [R 76]
  | 1264 -> One [R 77]
  | 1265 -> One [R 285; R 286]
  | 1266 -> One [R 286]
  | 1267 -> One [r423]
  | 1268 -> One [r422]
  | 1269 -> One [R 270; r469]
  | 1270 -> One [r469]
  | 1271 -> One [r468]
  | 1272 -> One [r467]
  | 1273 -> One [r466]
  | 1274 -> One [r465]
  | 1275 -> One [r464]
  | 1276 -> One [r463]
  | 1277 -> One [R 265]
  | 1278 -> One [R 94]
  | 1279 -> One [r420]
  | 1280 -> One [r419]
  | 1281 -> One [r418]
  | 1282 -> One [r417]
  | 1283 -> One [r416]
  | 1284 -> One [r415]
  | 1285 -> One [S (T T_COLON); r472]
  | 1286 -> One [r472]
  | 1287 -> One [r471]
  | 1288 -> One [r470]
  | 1289 -> One [r457]
  | 1290 -> One [R 546]
  | 1291 -> One [S (T T_MINUSGREATER); r473]
  | 1292 -> One [r473]
  | 1293 -> One [r13; r475]
  | 1294 -> One [r475]
  | 1295 -> One [r474]
  | 1296 -> One [R 95]
  | 1297 -> One [R 80]
  | 1298 -> One [R 91]
  | 1299 -> One [R 90]
  | 1300 -> One [R 93]
  | 1301 -> One [R 92]
  | 1302 -> One [r414]
  | 1303 -> One [r413]
  | 1304 -> One [R 270; r482]
  | 1305 -> One [r482]
  | 1306 -> One [r481]
  | 1307 -> One [r480]
  | 1308 -> One [r479]
  | 1309 -> One [r478]
  | 1310 -> One [r477]
  | 1311 -> One [r476]
  | 1312 -> One [R 263]
  | 1313 -> One [R 594]
  | 1314 -> One [R 580]
  | 1315 -> One [R 278; R 280]
  | 1316 -> One [R 585]
  | 1317 -> One [R 581]
  | 1318 -> One [R 592]
  | 1319 -> One [R 591]
  | 1320 -> One [R 590]
  | 1321 -> One [R 588]
  | 1322 -> One [R 280]
  | 1323 -> One [R 276; R 578]
  | 1324 -> One [R 578]
  | 1325 -> One [R 272; R 582]
  | 1326 -> One [R 270; r488]
  | 1327 -> One [r488]
  | 1328 -> One [r487]
  | 1329 -> One [r486]
  | 1330 -> One [r485]
  | 1331 -> One [r484]
  | 1332 -> One [r483]
  | 1333 -> One [R 273]
  | 1334 -> One [R 582]
  | 1335 -> One [R 274; R 583]
  | 1336 -> One [R 270; r495]
  | 1337 -> One [r495]
  | 1338 -> One [r494]
  | 1339 -> One [r493]
  | 1340 -> One [r492]
  | 1341 -> One [r319]
  | 1342 -> One [r320; r496]
  | 1343 -> One [r496]
  | 1344 -> One [R 390]
  | 1345 -> One [R 386]
  | 1346 -> One [R 115]
  | 1347 -> One [r498]
  | 1348 -> One [r497]
  | 1349 -> One [R 206]
  | 1350 -> One [R 116]
  | 1351 -> One [r499]
  | 1352 -> One [R 517]
  | 1353 -> One [r491]
  | 1354 -> One [r490]
  | 1355 -> One [r489]
  | 1356 -> One [R 275]
  | 1357 -> One [R 515]
  | 1358 -> One [R 516]
  | 1359 -> One [R 380]
  | 1360 -> One [S (T T_DOTDOT); R 388]
  | 1361 -> One [S (T T_DOTDOT); R 389]
  | 1362 -> One [r320; r500]
  | 1363 -> One [r500]
  | 1364 -> One [R 393]
  | 1365 -> One [R 389]
  | 1366 -> One [R 385]
  | 1367 -> One [r502]
  | 1368 -> One [r501]
  | 1369 -> One [R 207]
  | 1370 -> One [r320; r503]
  | 1371 -> One [r503]
  | 1372 -> One [R 392]
  | 1373 -> One [R 388]
  | 1374 -> One [R 384]
  | 1375 -> One [R 382]
  | 1376 -> One [R 583]
  | 1377 -> One [R 579]
  | 1378 -> One [R 595]
  | 1379 -> One [R 279]
  | 1380 -> One [R 494]
  | 1381 -> One [R 577]
  | 1382 -> One [R 495]
  | 1383 -> One [R 179; r512]
  | 1384 -> One [r512]
  | 1385 -> One [r511]
  | 1386 -> One [r510]
  | 1387 -> One [r509]
  | 1388 -> One [r508]
  | 1389 -> One [r504]
  | 1390 -> One [R 270; r515]
  | 1391 -> One [r515]
  | 1392 -> One [r514]
  | 1393 -> One [R 270; r519; r520]
  | 1394 -> One [R 270; r524]
  | 1395 -> One [r524]
  | 1396 -> One [r523]
  | 1397 -> One [r522]
  | 1398 -> One [r521]
  | 1399 -> One [R 785]
  | 1400 -> One [S (T T_EQUAL); r525]
  | 1401 -> One [r525]
  | 1402 -> One [R 787]
  | 1403 -> One [r520]
  | 1404 -> One [R 55]
  | 1405 -> One [r519]
  | 1406 -> One [R 791]
  | 1407 -> One [R 793]
  | 1408 -> One [R 369]
  | 1409 -> One [R 792]
  | 1410 -> One [S (T T_LIDENT); r527]
  | 1411 -> One [r527]
  | 1412 -> One [r526]
  | 1413 -> One [R 783]
  | 1414 -> One [r518]
  | 1415 -> One [r517]
  | 1416 -> One [r516]
  | 1417 -> One [R 784]
  | 1418 -> One [S (T T_EQUAL); r528]
  | 1419 -> One [r528]
  | 1420 -> One [R 786]
  | 1421 -> One [R 270; r531; r532]
  | 1422 -> One [R 270; r535]
  | 1423 -> One [r535]
  | 1424 -> One [R 505]
  | 1425 -> One [r534]
  | 1426 -> One [r533]
  | 1427 -> One [r17; r537]
  | 1428 -> One [r144; r541]
  | 1429 -> One [r541]
  | 1430 -> One [r540]
  | 1431 -> One [r539]
  | 1432 -> One [r538]
  | 1433 -> One [R 316]
  | 1434 -> One [r537]
  | 1435 -> One [r536]
  | 1436 -> One [R 314]
  | 1437 -> One [R 312]
  | 1438 -> One [r532]
  | 1439 -> One [R 56]
  | 1440 -> One [r531]
  | 1441 -> One [R 794]
  | 1442 -> One [R 796]
  | 1443 -> One [R 505]
  | 1444 -> One [R 795]
  | 1445 -> One [S (T T_LIDENT); r543]
  | 1446 -> One [r543]
  | 1447 -> One [r542]
  | 1448 -> One [R 310]
  | 1449 -> One [r530]
  | 1450 -> One [r529]
  | 1451 -> One [r17; r545]
  | 1452 -> One [r144; r549]
  | 1453 -> One [r549]
  | 1454 -> One [r548]
  | 1455 -> One [r547]
  | 1456 -> One [r546]
  | 1457 -> One [R 315]
  | 1458 -> One [r545]
  | 1459 -> One [r544]
  | 1460 -> One [R 313]
  | 1461 -> One [R 311]
  | 1462 -> One [R 270; r551]
  | 1463 -> One [r551]
  | 1464 -> One [r550]
  | 1465 -> One [R 58]
  | 1466 -> One [R 270; r554]
  | 1467 -> One [R 270; r557]
  | 1468 -> One [r557]
  | 1469 -> One [S (N N_class_expr); r558]
  | 1470 -> One [S (T T_OPEN); r562]
  | 1471 -> One [r562]
  | 1472 -> One [R 270; r565]
  | 1473 -> One [r565]
  | 1474 -> One [r564]
  | 1475 -> One [r563]
  | 1476 -> One [r454; r567]
  | 1477 -> One [r567]
  | 1478 -> One [r566]
  | 1479 -> One [R 87]
  | 1480 -> One [R 270; r570]
  | 1481 -> One [r570]
  | 1482 -> One [r569]
  | 1483 -> One [r568]
  | 1484 -> One [S (T T_IN); r571]
  | 1485 -> One [r571]
  | 1486 -> One [R 52]
  | 1487 -> One [R 45]
  | 1488 -> One [R 51]
  | 1489 -> One [R 86]
  | 1490 -> One [R 47]
  | 1491 -> One [R 50]
  | 1492 -> One [R 251]
  | 1493 -> One [R 64]
  | 1494 -> One [R 65]
  | 1495 -> One [R 46]
  | 1496 -> One [R 49]
  | 1497 -> One [r561]
  | 1498 -> One [r560]
  | 1499 -> One [r559]
  | 1500 -> One [R 48]
  | 1501 -> One [R 511; r573]
  | 1502 -> One [r573]
  | 1503 -> One [r572]
  | 1504 -> One [R 250]
  | 1505 -> One [r558]
  | 1506 -> One [R 85]
  | 1507 -> One [S (N N_class_type); r574]
  | 1508 -> One [r574]
  | 1509 -> One [R 88]
  | 1510 -> One [r556]
  | 1511 -> One [S (T T_LIDENT); R 437]
  | 1512 -> One [R 437]
  | 1513 -> One [r555]
  | 1514 -> One [R 54]
  | 1515 -> One [r554]
  | 1516 -> One [r553]
  | 1517 -> One [r552]
  | 1518 -> One [R 53]
  | 1519 -> One [R 270; r576]
  | 1520 -> One [r576]
  | 1521 -> One [r575]
  | 1522 -> One [R 57]
  | 1523 -> One [r513]
  | 1524 -> One [R 89]
  | 1525 -> One [R 276; R 59]
  | 1526 -> One [R 59]
  | 1527 -> One [R 60]
  | 1528 -> One [R 287; R 288]
  | 1529 -> One [R 288]
  | 1530 -> One [R 61]
  | 1531 -> One [S (N N_class_type); r578]
  | 1532 -> One [r578]
  | 1533 -> One [r577]
  | 1534 -> One [R 62]
  | 1535 -> One [r505; R 63]
  | 1536 -> One [R 63]
  | 1537 -> One [r507]
  | 1538 -> One [r506]
  | 1539 -> One [R 270; r584]
  | 1540 -> One [r584]
  | 1541 -> One [r583]
  | 1542 -> One [r582]
  | 1543 -> One [r581]
  | 1544 -> One [r580]
  | 1545 -> One [r579]
  | 1546 -> One [R 261]
  | 1547 -> One [R 736]
  | 1548 -> One [R 728]
  | 1549 -> One [R 281; R 284]
  | 1550 -> One [r585]
  | 1551 -> One [R 731]
  | 1552 -> One [R 717]
  | 1553 -> One [R 727]
  | 1554 -> One [R 735]
  | 1555 -> One [R 734]
  | 1556 -> One [R 284]
  | 1557 -> One [R 724]
  | 1558 -> One [R 276; R 725]
  | 1559 -> One [R 725]
  | 1560 -> One [R 272; R 729]
  | 1561 -> One [R 729]
  | 1562 -> One [R 726]
  | 1563 -> One [R 737]
  | 1564 -> One [R 493]
  | 1565 -> One [R 276; r586]
  | 1566 -> One [r586]
  | 1567 -> One [R 723]
  | 1568 -> One [r362]
  | 1569 -> One [R 185]
  | 1570 -> One [R 722]
  | 1571 -> One [R 724]
  | 1572 -> One [r360]
  | 1573 -> One [R 217]
  | 1574 -> One [R 276; r587]
  | 1575 -> One [r587]
  | 1576 -> One [R 283]
  | 1577 -> One [R 282]
  | 1578 -> One [r84]
  | 1579 -> One [R 344]
  | 1580 -> One [R 358]
  | 1581 -> One [r80]
  | 1582 -> One [R 653]
  | 1583 -> One [r75]
  | 1584 -> One [R 67]
  | 1585 -> One [r16; r588]
  | 1586 -> One [r588]
  | 1587 -> One [R 68]
  | 1588 -> One [r72]
  | 1589 -> One [r71]
  | 1590 -> One [R 621]
  | 1591 -> One [r67]
  | 1592 -> One [r66]
  | 1593 -> One [R 130]
  | 1594 -> One [r60]
  | 1595 -> One [R 502]
  | 1596 -> One [R 209]
  | 1597 -> One [r593]
  | 1598 -> One [r592]
  | 1599 -> One [r591]
  | 1600 -> One [r499]
  | 1601 -> One [r498]
  | 1602 -> One [r375; r594]
  | 1603 -> One [r594]
  | 1604 -> One [R 183]
  | 1605 -> One [r590]
  | 1606 -> One [R 730]
  | 1607 -> One [R 522]
  | 1608 -> One [R 523]
  | 1609 -> One [R 518]
  | 1610 -> One [R 520]
  | 1611 -> One [R 519]
  | 1612 -> One [R 521]
  | 1613 -> One [r502]
  | 1614 -> One [r375; r595]
  | 1615 -> One [r595]
  | 1616 -> One [R 184]
  | 1617 -> One [r56]
  | 1618 -> One [R 181]
  | 1619 -> One [r54]
  | 1620 -> One [R 307]
  | 1621 -> One [R 270; R 305]
  | 1622 -> One [R 305]
  | 1623 -> One [R 309]
  | 1624 -> One [R 303]
  | 1625 -> One [R 308]
  | 1626 -> One [R 306]
  | 1627 -> One [R 304]
  | 1628 -> One [R 30]
  | 1629 -> One [S (T T_GREATER); R 29]
  | 1630 -> One [R 29]
  | 1631 -> One [r51]
  | 1632 -> One [r50]
  | 1633 -> One [R 196]
  | 1634 -> One [S (T T_RPAREN); r596]
  | 1635 -> One [r596]
  | 1636 -> One [r123; R 33]
  | 1637 -> One [R 33]
  | 1638 -> One [R 28]
  | 1639 -> One [r16; R 552]
  | 1640 -> One [R 552]
  | 1641 -> One [S (T T_RPAREN); R 22]
  | 1642 -> One [R 22]
  | 1643 -> One [r16; R 553]
  | 1644 -> One [R 553]
  | 1645 -> One [r320; r597]
  | 1646 -> One [r597]
  | 1647 -> One [R 391]
  | 1648 -> One [R 387]
  | 1649 -> One [R 381]
  | 1650 -> One [R 383]
  | 1651 -> One [R 760]
  | 1652 -> One [r40]
  | 1653 -> One [r39]
  | 1654 -> One [R 210]
  | 1657 -> One [r47; r599]
  | 1658 -> One [r599]
  | 1659 -> One [r598]
  | 1660 -> One [R 208]
  | 1661 -> One [r603]
  | 1662 -> One [r602]
  | 1663 -> One [r601]
  | 1664 -> One [r600]
  | 1665 -> One [R 584]
  | 1666 -> One [R 526]
  | 1667 -> One [R 524]
  | 1668 -> One [R 525]
  | 1669 -> One [r37]
  | 1670 -> One [R 356]
  | 1671 -> One [r30]
  | 1672 -> One [R 23]
  | 1673 -> One [r18]
  | 1674 -> One [R 788]
  | 1675 -> One [r9]
  | 1676 -> One [R 44]
  | 1677 -> One [r4]
  | 1678 -> One [r3]
  | 1679 -> One [r2]
  | 1680 -> One [r1]
  | 1681 -> One [R 133]
  | 1682 -> One [S (T T_EOF); R 213]
  | 1683 -> One [R 213]
  | 1684 -> One [R 0]
  | 1686 -> One [S (T T_EOF); R 216]
  | 1687 -> One [R 216]
  | 1688 -> One [R 1]
  | 1690 -> One [r604]
  | 1691 -> One [S (T T_RPAREN); R 320]
  | 1692 -> One [R 320]
  | 1693 -> One [R 321]
  | 1694 -> One [R 2]
  | 1695 -> One [r605]
  | 1696 -> One [r126]
  | 1697 -> One [S (T T_COLONCOLON); r606]
  | 1698 -> One [r606]
  | 1699 -> One [R 323]
  | 1700 -> One [R 324]
  | 1701 -> One [R 322]
  | 1702 -> One [R 20]
  | 1703 -> One [R 319]
  | 1704 -> One [R 21]
  | 1705 -> One [S (T T_EOF); R 458]
  | 1706 -> One [R 458]
  | 1708 -> One [R 3]
  | 1709 -> One [S (T T_EOF); R 459]
  | 1710 -> One [R 459]
  | 1712 -> One [R 4]
  | 1713 -> One [S (T T_EOF); R 460]
  | 1714 -> One [R 460]
  | 1716 -> One [S (T T_EOF); R 461]
  | 1717 -> One [R 461]
  | 1718 -> One [R 5]
  | 1720 -> One [R 6]
  | 1721 -> One [S (T T_EOF); R 462]
  | 1722 -> One [R 462]
  | 1724 -> One [R 7]
  | 1725 -> One [S (T T_EOF); R 463]
  | 1726 -> One [R 463]
  | 1728 -> One [R 8]
  | 1729 -> One [S (T T_EOF); R 464]
  | 1730 -> One [R 464]
  | 1732 -> One [R 9]
  | 1733 -> One [S (T T_EOF); R 465]
  | 1734 -> One [R 465]
  | 1736 -> One [R 10]
  | 1737 -> One [S (T T_EOF); R 466]
  | 1738 -> One [R 466]
  | 1740 -> One [S (T T_EOF); R 467]
  | 1741 -> One [R 467]
  | 1742 -> One [R 11]
  | 1744 -> One [S (T T_EOF); R 468]
  | 1745 -> One [R 468]
  | 1746 -> One [R 12]
  | 1747 -> One [S (T T_DOT); r191]
  | 1748 -> One [r191]
  | 1750 -> One [r34; R 743]
  | 1751 -> One [R 743]
  | 1752 -> One [R 749]
  | 1753 -> One [R 744]
  | 1754 -> One [R 745]
  | 1755 -> One [R 748]
  | 1756 -> One [R 746]
  | 1757 -> One [R 747]
  | 1758 -> One [R 753]
  | 1759 -> One [R 13]
  | 1760 -> One [S (T T_SEMISEMI); R 752]
  | 1761 -> One [R 752]
  | 1762 -> One [R 289; R 290]
  | 1763 -> One [R 290]
  | 1764 -> One [R 276; r607]
  | 1765 -> One [r607]
  | 1766 -> One [R 750]
  | 1767 -> One [S (T T_SEMISEMI); R 751]
  | 1768 -> One [R 751]
  | 1770 -> One [R 291; R 292]
  | 1771 -> One [R 291; R 295]
  | 1772 -> One [R 291; R 294]
  | 1773 -> One [R 294]
  | 1774 -> One [R 295]
  | 1775 -> One [R 276; r608]
  | 1776 -> One [r608]
  | 1777 -> One [R 293]
  | 1778 -> One [R 292]
  | 1779 -> One [R 14]
  | 1780 -> One [R 276; r610]
  | 1781 -> One [r610]
  | 1782 -> One [r609]
  | 1783 -> One [R 778]
  | 1784 -> One [S (T T_EOF); R 777]
  | 1785 -> One [R 777]
  | 116 -> Select (function
    | 715 | 998 -> [r35]
    | _ -> [r34; R 535])
  | 119 -> Select (function
    | 715 | 998 -> [R 24]
    | _ -> [R 535])
  | 133 -> Select (function
    | -1 -> [r615]
    | _ -> [R 179; r618])
  | 134 -> Select (function
    | -1 -> [r614]
    | _ -> [r618])
  | 135 -> Select (function
    | -1 -> [r613]
    | _ -> [r617])
  | 163 -> Select (function
    | -1 -> [R 317]
    | _ -> [S (T T_COLON); r52])
  | 175 -> Select (function
    | -1 -> [r615]
    | _ -> [R 179; r621])
  | 176 -> Select (function
    | -1 -> [r614]
    | _ -> [r621])
  | 177 -> Select (function
    | -1 -> [r613]
    | _ -> [r620])
  | 178 -> Select (function
    | -1 -> [r612]
    | _ -> [r619])
  | 179 -> Select (function
    | -1 -> [r611]
    | _ -> [R 317])
  | 200 -> Select (function
    | 251 | 558 | 895 -> [r24]
    | -1 -> [r604]
    | _ -> [r143])
  | 246 -> Select (function
    | -1 -> [r604]
    | _ -> [r0; r340])
  | 249 -> Select (function
    | -1 -> [R 780]
    | _ -> [S (T T_LESSMINUS); r105])
  | 253 -> Select (function
    | -1 -> [r319]
    | _ -> [S (N N_pattern); R 566; r151])
  | 271 -> Select (function
    | -1 -> [r605]
    | _ -> [S (T T_DOT); r622])
  | 277 -> Select (function
    | -1 -> [r126]
    | _ -> [r622])
  | 363 -> Select (function
    | -1 -> [R 107]
    | _ -> [S (T T_DOT); r623])
  | 364 -> Select (function
    | -1 -> [r191]
    | _ -> [r623])
  | 378 -> Select (function
    | -1 -> [R 658]
    | _ -> [S (N N_pattern); R 483])
  | 381 -> Select (function
    | -1 -> [R 657]
    | _ -> [S (N N_pattern); R 481])
  | 442 -> Select (function
    | 60 | 172 | 183 | 216 | 1088 | 1094 -> [r585]
    | _ -> [S (T T_OPEN); r161])
  | 482 -> Select (function
    | -1 -> [r605]
    | _ -> [S (T T_DOT); r624])
  | 483 -> Select (function
    | -1 -> [r126]
    | _ -> [r624])
  | 484 -> Select (function
    | -1 -> [R 337]
    | _ -> [R 211])
  | 526 -> Select (function
    | -1 -> [r319]
    | _ -> [r241; r302])
  | 543 -> Select (function
    | -1 -> [R 107]
    | _ -> [r301])
  | 544 -> Select (function
    | -1 -> [r191]
    | _ -> [r300])
  | 1062 -> Select (function
    | -1 -> [r625]
    | _ -> [R 179; r352])
  | 1115 -> Select (function
    | -1 -> [r412]
    | _ -> [R 179; r628])
  | 1116 -> Select (function
    | -1 -> [r411]
    | _ -> [r628])
  | 1117 -> Select (function
    | -1 -> [r410]
    | _ -> [r627])
  | 1118 -> Select (function
    | -1 -> [r409]
    | _ -> [r626])
  | 1120 -> Select (function
    | -1 -> [r604]
    | _ -> [S (T T_COLONCOLON); r147])
  | 1142 -> Select (function
    | -1 -> [r625]
    | _ -> [R 179; r394])
  | 1143 -> Select (function
    | -1 -> [r348]
    | _ -> [R 179; r631])
  | 1144 -> Select (function
    | -1 -> [r347]
    | _ -> [r631])
  | 1145 -> Select (function
    | -1 -> [r346]
    | _ -> [r630])
  | 1146 -> Select (function
    | -1 -> [r345]
    | _ -> [r629])
  | 1655 -> Select (function
    | -1 -> [r612]
    | _ -> [r616])
  | 1656 -> Select (function
    | -1 -> [r611]
    | _ -> [R 317])
  | _ -> raise Not_found
let token_of_terminal (type a) (t : a MenhirInterpreter.terminal) (v : a) : token =
  match t with
  | MenhirInterpreter.T_error -> assert false
  | MenhirInterpreter.T_WITH -> WITH
  | MenhirInterpreter.T_WHILE -> WHILE
  | MenhirInterpreter.T_WHEN -> WHEN
  | MenhirInterpreter.T_VIRTUAL -> VIRTUAL
  | MenhirInterpreter.T_VAL -> VAL
  | MenhirInterpreter.T_UNDERSCORE -> UNDERSCORE
  | MenhirInterpreter.T_UIDENT -> UIDENT v
  | MenhirInterpreter.T_TYPE_DISAMBIGUATOR -> TYPE_DISAMBIGUATOR v
  | MenhirInterpreter.T_TYPE -> TYPE
  | MenhirInterpreter.T_TRY -> TRY
  | MenhirInterpreter.T_TRUE -> TRUE
  | MenhirInterpreter.T_TO -> TO
  | MenhirInterpreter.T_TILDE -> TILDE
  | MenhirInterpreter.T_THEN -> THEN
  | MenhirInterpreter.T_STRUCT -> STRUCT
  | MenhirInterpreter.T_STRING -> STRING v
  | MenhirInterpreter.T_STAR -> STAR
  | MenhirInterpreter.T_SLASH -> SLASH
  | MenhirInterpreter.T_SIG -> SIG
  | MenhirInterpreter.T_SEMISEMI -> SEMISEMI
  | MenhirInterpreter.T_SEMI -> SEMI
  | MenhirInterpreter.T_RPAREN -> RPAREN
  | MenhirInterpreter.T_REC -> REC
  | MenhirInterpreter.T_RBRACKET -> RBRACKET
  | MenhirInterpreter.T_RBRACE -> RBRACE
  | MenhirInterpreter.T_QUOTED_STRING_ITEM -> QUOTED_STRING_ITEM v
  | MenhirInterpreter.T_QUOTED_STRING_EXPR -> QUOTED_STRING_EXPR v
  | MenhirInterpreter.T_QUOTE -> QUOTE
  | MenhirInterpreter.T_QUESTION -> QUESTION
  | MenhirInterpreter.T_PRIVATE -> PRIVATE
  | MenhirInterpreter.T_PREFIXOP -> PREFIXOP v
  | MenhirInterpreter.T_PLUSEQ -> PLUSEQ
  | MenhirInterpreter.T_PLUSDOT -> PLUSDOT
  | MenhirInterpreter.T_PLUS -> PLUS
  | MenhirInterpreter.T_PERCENT -> PERCENT
  | MenhirInterpreter.T_OR -> OR
  | MenhirInterpreter.T_OPTLABEL -> OPTLABEL v
  | MenhirInterpreter.T_OPEN -> OPEN
  | MenhirInterpreter.T_OF -> OF
  | MenhirInterpreter.T_OBJECT -> OBJECT
  | MenhirInterpreter.T_NONREC -> NONREC
  | MenhirInterpreter.T_NEW -> NEW
  | MenhirInterpreter.T_MUTABLE -> MUTABLE
  | MenhirInterpreter.T_MODULE -> MODULE
  | MenhirInterpreter.T_MINUSGREATER -> MINUSGREATER
  | MenhirInterpreter.T_MINUSDOT -> MINUSDOT
  | MenhirInterpreter.T_MINUS -> MINUS
  | MenhirInterpreter.T_METHOD -> METHOD
  | MenhirInterpreter.T_MATCH -> MATCH
  | MenhirInterpreter.T_LPAREN -> LPAREN
  | MenhirInterpreter.T_LIDENT -> LIDENT v
  | MenhirInterpreter.T_LETOP -> LETOP v
  | MenhirInterpreter.T_LET -> LET
  | MenhirInterpreter.T_LESSMINUS -> LESSMINUS
  | MenhirInterpreter.T_LESS -> LESS
  | MenhirInterpreter.T_LBRACKETPERCENTPERCENT -> LBRACKETPERCENTPERCENT
  | MenhirInterpreter.T_LBRACKETPERCENT -> LBRACKETPERCENT
  | MenhirInterpreter.T_LBRACKETLESS -> LBRACKETLESS
  | MenhirInterpreter.T_LBRACKETGREATER -> LBRACKETGREATER
  | MenhirInterpreter.T_LBRACKETBAR -> LBRACKETBAR
  | MenhirInterpreter.T_LBRACKETATATAT -> LBRACKETATATAT
  | MenhirInterpreter.T_LBRACKETATAT -> LBRACKETATAT
  | MenhirInterpreter.T_LBRACKETAT -> LBRACKETAT
  | MenhirInterpreter.T_LBRACKET -> LBRACKET
  | MenhirInterpreter.T_LBRACELESS -> LBRACELESS
  | MenhirInterpreter.T_LBRACE -> LBRACE
  | MenhirInterpreter.T_LAZY -> LAZY
  | MenhirInterpreter.T_LABEL -> LABEL v
  | MenhirInterpreter.T_INT -> INT v
  | MenhirInterpreter.T_INITIALIZER -> INITIALIZER
  | MenhirInterpreter.T_INHERIT -> INHERIT
  | MenhirInterpreter.T_INFIXOP4 -> INFIXOP4 v
  | MenhirInterpreter.T_INFIXOP3 -> INFIXOP3 v
  | MenhirInterpreter.T_INFIXOP2 -> INFIXOP2 v
  | MenhirInterpreter.T_INFIXOP1 -> INFIXOP1 v
  | MenhirInterpreter.T_INFIXOP0 -> INFIXOP0 v
  | MenhirInterpreter.T_INCLUDE -> INCLUDE
  | MenhirInterpreter.T_IN -> IN
  | MenhirInterpreter.T_IF -> IF
  | MenhirInterpreter.T_HASHOP -> HASHOP v
  | MenhirInterpreter.T_HASH -> HASH
  | MenhirInterpreter.T_GREATERRBRACKET -> GREATERRBRACKET
  | MenhirInterpreter.T_GREATERRBRACE -> GREATERRBRACE
  | MenhirInterpreter.T_GREATER -> GREATER
  | MenhirInterpreter.T_FUNCTOR -> FUNCTOR
  | MenhirInterpreter.T_FUNCTION -> FUNCTION
  | MenhirInterpreter.T_FUN -> FUN
  | MenhirInterpreter.T_FOR -> FOR
  | MenhirInterpreter.T_FLOAT -> FLOAT v
  | MenhirInterpreter.T_FALSE -> FALSE
  | MenhirInterpreter.T_EXTERNAL -> EXTERNAL
  | MenhirInterpreter.T_EXCEPTION -> EXCEPTION
  | MenhirInterpreter.T_EQUAL -> EQUAL
  | MenhirInterpreter.T_EOL -> EOL
  | MenhirInterpreter.T_EOF -> EOF
  | MenhirInterpreter.T_END -> END
  | MenhirInterpreter.T_ELSE -> ELSE
  | MenhirInterpreter.T_DOWNTO -> DOWNTO
  | MenhirInterpreter.T_DOTOP -> DOTOP v
  | MenhirInterpreter.T_DOTDOT -> DOTDOT
  | MenhirInterpreter.T_DOT -> DOT
  | MenhirInterpreter.T_DONE -> DONE
  | MenhirInterpreter.T_DOCSTRING -> DOCSTRING v
  | MenhirInterpreter.T_DO -> DO
  | MenhirInterpreter.T_CONSTRAINT -> CONSTRAINT
  | MenhirInterpreter.T_COMMENT -> COMMENT v
  | MenhirInterpreter.T_COMMA -> COMMA
  | MenhirInterpreter.T_COLONGREATER -> COLONGREATER
  | MenhirInterpreter.T_COLONEQUAL -> COLONEQUAL
  | MenhirInterpreter.T_COLONCOLON -> COLONCOLON
  | MenhirInterpreter.T_COLON -> COLON
  | MenhirInterpreter.T_CLASS -> CLASS
  | MenhirInterpreter.T_CHAR -> CHAR v
  | MenhirInterpreter.T_BEGIN -> BEGIN
  | MenhirInterpreter.T_BARRBRACKET -> BARRBRACKET
  | MenhirInterpreter.T_BARBAR -> BARBAR
  | MenhirInterpreter.T_BAR -> BAR
  | MenhirInterpreter.T_BANG -> BANG
  | MenhirInterpreter.T_BACKQUOTE -> BACKQUOTE
  | MenhirInterpreter.T_ASSERT -> ASSERT
  | MenhirInterpreter.T_AS -> AS
  | MenhirInterpreter.T_ANDOP -> ANDOP v
  | MenhirInterpreter.T_AND -> AND
  | MenhirInterpreter.T_AMPERSAND -> AMPERSAND
  | MenhirInterpreter.T_AMPERAMPER -> AMPERAMPER
let nullable (type a) : a MenhirInterpreter.nonterminal -> bool =
  let open MenhirInterpreter in function
  | N_virtual_flag -> true
  | N_type_variance -> true
  | N_type_parameters -> true
  | N_type_kind -> true
  | N_structure -> true
  | N_signature -> true
  | N_reversed_llist_preceded_CONSTRAINT_constrain__ -> true
  | N_rec_flag -> true
  | N_private_virtual_flags -> true
  | N_private_flag -> true
  | N_payload -> true
  | N_option_type_constraint_ -> true
  | N_option_preceded_EQUAL_seq_expr__ -> true
  | N_option_preceded_EQUAL_pattern__ -> true
  | N_option_preceded_EQUAL_module_type__ -> true
  | N_option_preceded_EQUAL_expr__ -> true
  | N_option_preceded_COLON_core_type__ -> true
  | N_option_preceded_AS_mkrhs_LIDENT___ -> true
  | N_option_SEMI_ -> true
  | N_option_BAR_ -> true
  | N_opt_ampersand -> true
  | N_mutable_virtual_flags -> true
  | N_mutable_flag -> true
  | N_list_use_file_element_ -> true
  | N_list_text_str_structure_item__ -> true
  | N_list_text_cstr_class_field__ -> true
  | N_list_text_csig_class_sig_field__ -> true
  | N_list_structure_element_ -> true
  | N_list_signature_element_ -> true
  | N_list_post_item_attribute_ -> true
  | N_list_generic_and_type_declaration_type_subst_kind__ -> true
  | N_list_generic_and_type_declaration_type_kind__ -> true
  | N_list_attribute_ -> true
  | N_list_and_module_declaration_ -> true
  | N_list_and_module_binding_ -> true
  | N_list_and_class_type_declaration_ -> true
  | N_list_and_class_description_ -> true
  | N_list_and_class_declaration_ -> true
  | N_index_mod -> true
  | N_generalized_constructor_arguments -> true
  | N_formal_class_parameters -> true
  | N_ext -> true
  | N_class_self_type -> true
  | N_class_self_pattern -> true
  | _ -> false
